--
-- task group relations dao.find by task group id.
--
SELECT
    TG.*
   ,T1.all_tasks
   ,T2.done_tasks
FROM 
    (
    SELECT DISTINCT
        G.id AS task_group_id
       ,G.name
       ,G.description 
       ,G.start_date
       ,G.deadline
       ,G.registered
       ,G.modified
       ,G.user_id
       ,A.activity_id
       ,V.name AS activity_name
       ,AC.color AS activity_color
    FROM
        task_groups G
        INNER JOIN task_group_activities A ON G.id = A.task_group_id
        INNER JOIN activities            V ON A.activity_id = V.id
        INNER JOIN activity_relations   AR ON A.activity_id = AR.activity_id
                                          AND AR.user_id = /*userId*/1
        INNER JOIN activity_colors      AC ON AR.color_id = AC.id
    WHERE
        G.del_flag = '0'
    AND A.activity_id IN (
            SELECT A1.id
            FROM activities A1
                INNER JOIN activity_members A2 ON A1.id = A2.activity_id
            WHERE
                A2.user_id = /*userId*/1
        )
    AND G.id = /*taskGroupId*/1
    ) TG
    LEFT JOIN (
        SELECT
            COUNT(*) AS all_tasks
           ,R2.task_group_id
        FROM
            task_relations TR1
            INNER JOIN tasks TA1                 ON TR1.task_id = TA1.id
                                                AND TA1.del_flag = '0'
            INNER JOIN task_group_relations R2   ON TR1.task_id = R2.task_id
            INNER JOIN task_group_activities GA1 ON R2.task_group_id = GA1.task_group_id
                                                AND TR1.activity_id = GA1.activity_id
        WHERE
            R2.task_group_id = /*taskGroupId*/1
        GROUP BY
            R2.task_group_id
        ) T1 ON TG.task_group_id = T1.task_group_id
    LEFT JOIN (
        SELECT
            COUNT(*) AS done_tasks
           ,R3.task_group_id
        FROM
            task_relations TR2
            INNER JOIN tasks TA2                 ON TR2.task_id = TA2.id
                                                AND TA2.del_flag = '0'
            INNER JOIN task_group_relations R3   ON TR2.task_id = R3.task_id
            INNER JOIN task_group_activities GA2 ON R3.task_group_id = GA2.task_group_id
                                                AND TR2.activity_id = GA2.activity_id
        WHERE
            R3.task_group_id = /*taskGroupId*/1
        AND TR2.status_id = 3
        GROUP BY
            R3.task_group_id
        ) T2 ON TG.task_group_id = T2.task_group_id
ORDER BY
    TG.activity_id
   ,TG.task_group_id