/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
if (typeof(Tugboat.gtd_task) == 'undefined') {
    Tugboat.gtd_task = {};
}

Tugboat.gtd_task = {
  _task_list_json   : null,
  _activities       : null,
  _person_in_charge : null,

  _current_mode : 0, /* [0]:folder, [1]:tags, [2]:calendar, [3]:task-group */
 
  _is_visibled_browser      : false,
  _before_selected_foder_id : '',
  _prev_entry_key_code      : 0,

  _add_task_activity_selector : null, /* add a task.activity selector. */
  _is_ie6 : false,

  /**
   * Initialize.
   * 
   */
  init : function() {
    $('tag_filter').value = 'tags filter...';
    Tugboat.gtd_common.set_application_window_size();
    Tugboat.gtd_common.task._setup_task_droppables();
    Tugboat.dashboard.initialize();
    Tugboat.gtd_task_event_rule.setup_event_rules();
    
    var self = Tugboat.gtd_task;
    self._is_ie6 = navigator.userAgent.indexOf('MSIE 6.0') > -1;
    if (self._is_ie6) {
      Tugboat.gtd_task.selected_view_mode(Tugboat.constant.view_mode.BLOCK);
      $('layout_block').style.display = 'none';
      $('layout_list').style.display = 'none';
    }
    if (navigator.userAgent.indexOf('MSIE 7.0') > -1) {
      $('menuBar_KeyboardHelp').style.display = 'none';
    }
    
    self.browser.reset(false);
    self._get_activities_json();
    
    Tugboat.gtd_task.sub_window._setup_auto_completer();
    $('add_task_tags').setAttribute("AutoComplete", "off");
    $('task_tags').setAttribute("AutoComplete", "off");
    
    var group = Tugboat.gtd_task.task_group;
    group.task_group_tab_onclick();
    group._select_list();
    group._setup_task_group_drag_target();
    group._setup_context_menu();
    
    Tugboat.gtd_task.tag._setup_tags_drag_target();

    Calendar.setup({
      inputField  : 'edit_due1',
      displayArea : 'edit_due_display1',
      ifFormat    : '%Y%m%d',
      daFormat    : '%Y-%m-%d',
      button      : 'show_calendar_link1'
    });
    Calendar.setup({
      inputField  : 'edit_due2',
      displayArea : 'due_display',
      ifFormat    : '%Y%m%d',
      daFormat    : '%Y-%m-%d',
      button      : 'show_calendar_link2'
    });

    Calendar.setup({
      inputField  : 'new_task_group_start_edit',
      displayArea : 'new_task_group_start_display',
      ifFormat    : '%Y%m%d',
      daFormat    : '%Y-%m-%d',
      button      : 'new_task_group_start_show_link'
    });
    Calendar.setup({
      inputField  : 'new_task_group_deadline_edit',
      displayArea : 'new_task_group_deadline_display',
      ifFormat    : '%Y%m%d',
      daFormat    : '%Y-%m-%d',
      button      : 'new_task_group_deadline_show_link'
    });
  },
  
  /**
   * get activities json.
   * 
   * @param {Function} _get_before_view_statuses
   */
  _get_activities_json : function() {
    var self = Tugboat.gtd_task;
    new Ajax.Request(
      Tugboat.AJAX_SERVLET_NAME,
      { 
        method: Tugboat.constant.REQUEST_GET,
        parameters:
        {
          component:'taskAjax',
          action   :'getActivitiesJSON'
        },
        onComplete: function(transport){
          self._activities = eval(transport.responseText);
          
          var list = [];
          self._activities.each(
            function(a) {
              list.push(
                { id:a.id,
                  value:a.value, 
                  icon:'images/default/palette/sphere/pl_' + a.color + '_12x12.png'});
            }
          );
          
          Tugboat.gtd_task.sub_window._activity_selector1 = 
            new TugboatUI.SelectMenu(
              'add_task_activity_container', 
              list,
              { parentElement:'addTaskWindow',
                isParentWindow:true,
                onSelected:function(selectValue){
                  $('add_task_title').focus();
                  Tugboat.gtd_task.task_group._setup_select_menu_by_change_activity(
                    Tugboat.gtd_task.task_group._task_group_selector_for_edittask,
                    selectValue.id
                  );
                }
              }
            );

          Tugboat.gtd_task.task_group._activity_selector2 = 
            new TugboatUI.SelectMenu(
              'new_task_group_activity_container', 
              list,
              { parentElement:'newTaskGroupWindow',
                isParentWindow:true,
                onSelected:function(selectValue){ $('new_task_group_title').focus(); } }
            );

          Tugboat.gtd_task._add_task_activity_selector = 
            new TugboatUI.SelectMenu(
              'activity_container', 
              list,
              { parentElement:'content',
                isParentWindow:false,
                onSelected:function(selectValue){
                  $('task_title').focus();
                  Tugboat.gtd_task.task_group._setup_select_menu_by_change_activity(
                    Tugboat.gtd_task.task_group._task_group_selector_for_newtask,
                    selectValue.id
                  );
                }
              }
            );
          
          self._get_before_view_statuses();
        }
      }
    );
  },
  
  /**
   * get before view statuses.
   * 
   */
  _get_before_view_statuses : function() {
    var self = Tugboat.gtd_task;
    new Ajax.Request (
      Tugboat.AJAX_SERVLET_NAME,
      {
        method: Tugboat.constant.REQUEST_GET,
        parameters:
        {
          component:'taskAjax',
          action   :'getBeforeViewStatusesJSON'
        },
        onComplete: function(transport){
          if (Tugboat.isEmpty(transport.responseText)) return false;
          
          var json = eval('(' + transport.responseText + ')');
          var isExistChecked = false;

          self._activities.each(
            function(a) {
              var selected_activity = json.activities.find(
                function(s) {
                  return a.id == s;
                }
              );
              var before_checled = (typeof(selected_activity) != 'undefined');
              if (before_checled) isExistChecked = true;
              self.browser._activity_info.push(
                { id     :a.id, 
                  value  :a.value,
                  checked:before_checled,
                  color  :a.color
                }
              );
            }
          );

          if (isExistChecked) {
            var activity_value = self.browser._activity_info.find(
              function(a) {
                return a.id == 0;
              }
            );
            activity_value.checked = false;
          }
          Tugboat.gtd_task.browser._create_activity_list(self.browser._activity_info);
          self._get_person_in_charge_json(json);
        }
      }
    );
  },
  
  
  /**
   * set person in charge list.
   * 
   * @param {Object} json
   * 
   */
  _set_person_in_charge_list : function(json) {
    var self = Tugboat.gtd_task;
    var isExistChecked = false;
    
    self.browser._person_info = [];
    self._person_in_charge.each(
      function(p) {
        var is_before_selected = false;
        if (json) {
          var selected_person = json.people.find(
            function(s) {
              return p.personId == s;
            }
          );
          is_before_selected = (typeof(selected_person)!='undefined');
          if (typeof(selected_person)!='undefined') isExistChecked = true;
        }
        self.browser._person_info.push(
          { 'id'        :p.personId, 
            'checked'   :is_before_selected,
            'isMe'      :p.isMe, 
            'last_name' :p.personLastName,
            'first_name':p.personFirstName
          }
        );
      }
    );
    if (! isExistChecked) {
      var person_value = self.browser._person_info.find(
        function(p) { return (json ? p.id == 0 : p.isMe) }
      );
      person_value.checked = true;
    }
  },
  
  /**
   * get person in charge json.
   */
  _get_person_in_charge_json : function(json) {
    var self = Tugboat.gtd_task;
    var activityQueryParam = self.browser._get_activity_query_params();
    
    new Ajax.Request (
      Tugboat.AJAX_SERVLET_NAME,
      {
        method: Tugboat.constant.REQUEST_GET,
        parameters:
        {
          component   :'activityMemberAjax',
          action      :'getActivityMembersByActivities',
          activityIds :activityQueryParam
        },
        onComplete: function(transport){
          if (! transport.responseText) self._person_in_charge = null;
          else self._person_in_charge = eval(transport.responseText);

          self._set_person_in_charge_list(json);
          Tugboat.gtd_task.browser._create_person_in_charge_list(self.browser._person_info);
          
          // set browser visible. 
          $('browser_pane').style.display = 
            json.is_visible_browser == 0 ? Tugboat.constant.STYLE_DISPLAY_NONE : '';
          
          self._is_visibled_browser = json.is_visible_browser == 1;
          if (!self._is_ie6) {
            if (json.select_mode == 0) {
              Tugboat.gtd_common.block_select($('layout_block'));
              Tugboat.gtd_task._set_dragn_drop_today_style('block');
            }
            else {
              Tugboat.gtd_common.list_select($('layout_list'));
              Tugboat.gtd_task._set_dragn_drop_today_style('list');
            }
          }

          // get tags => create tag folder.
          Tugboat.gtd_task.tag._setup_tag_folder(true);
          
          self._current_mode = json.select_tab;
          var selected_class = 
            Tugboat.constant.task.findFolderByValue(json.select_class);

          // create task list doms.          
          Tugboat.gtd_task.folder.folder_onclick(selected_class.id, false, json);
          
          // get due list.
          Tugboat.gtd_task.calendar._get_due_list();
        }
      }
    );
  },
  
  /**
   * empty a trash box.
   */
  empty_trashbox_onclick : function() {
    if (! confirm('May I empty a trash box?')) return false;
    new Ajax.Request(
      Tugboat.AJAX_SERVLET_NAME,
      {
        method: Tugboat.constant.REQUEST_GET,
        parameters:
        {
          component:'taskAjax',
          action   :'emptyTrashBox'
        },
        onComplete: function(transport){
          Tugboat.gtd_task.folder.folder_onclick(
            TugboatUI.DragBox.selected_folder_id, true);
        }
      }
    );
  },
 
  shortcut_keys_window : null,
  
  /**
   * shortcut keys on click.
   * 
   */
  shortcut_keys_onclick : function() {
    Tugboat.gtd_task.modal.open();
    var self = Tugboat.gtd_task.sub_window;
      
    self.shortcut_keys_window = 
      new Window(
        'shortcutkeysInfo',
        { className: 'mac_os_x', width:320, height:80, 
          zIndex: 100, 
          minimizable: false, 
          closable   : false, 
          maximizable: false,
          resizable  : false, 
          draggable  : true,
          title      : 'Shortcut keys?'
         ,showEffectOptions:{
            duration:0
          }
        }
      );
    self.shortcut_keys_window.setContent('shortcut_keys_sub_window_container',false,false);
    self.shortcut_keys_window.setDestroyOnClose();
    self.shortcut_keys_window.showCenter();
      
    var taskWindowObserver = {
      onDestroy: function(eventName, win) {
        if (win == self.shortcut_keys_window) {
          Element.hide('shortcut_keys_sub_window_container');
          $('shortcut_keys_sub_window_container').appendChild($('shortcut_keys_sub_window'));
                     
          Windows.removeObserver(this);
          Tugboat.gtd_task.modal.close();
        }
      }
    };
    Windows.addObserver(taskWindowObserver);
  },
  
  /**
   * selected view mode.
   * 
   * @param {Number} modeId
   */
  selected_view_mode : function(modeId) {
    new Ajax.Request(
      Tugboat.AJAX_SERVLET_NAME,
      {
        method: Tugboat.constant.REQUEST_GET,
        parameters:
        {
          component  :'taskAjax',
          action     :'selectModeBlockOrList',
          selectMode :modeId
        },
        onComplete: function(transport){
        }
      }
    );
    return false;
  },
  
  /**
   * set drag and drop today pane style.
   * 
   * @param {String} selectedMode
   */
  _set_dragn_drop_today_style : function(selectedMode) {
    $('list_pane').className = 
      (selectedMode == 'block' ? 'block_mode' : 'list_mode');

    if (Tugboat.gtd_task._is_ie6) return false;
    var className = (selectedMode == 'block' ? 'gtdBox' : 'gtdList');
    
    TugboatUI.DragBox.drop_target_styles.each(
      function(t) {
        if (t.id.indexOf('list_top')    > -1
         || t.id.indexOf('list_middle') > -1 
         || t.id.indexOf('list_bottom') > -1 ) {
                
          t.defaultStyle  = className + ' clearfix';
          t.dragOverStyle = className + ' clearfix gtdBox_hover';
        }
      }
    );
  },
  
  /**
   * edit task.
   * 
   * @param {Object} id
   */
  edit_task : function(id) {
    Tugboat.gtd_task.progress.open();
    
    new Ajax.Request(
      Tugboat.AJAX_SERVLET_NAME,
      {   
        method: Tugboat.constant.REQUEST_GET,
        parameters: 
        {
          component : 'taskAjax',
          action    : 'getTaskForBalloonJSON',
          id        : id
        },
        onComplete: function(transport){
          if (Tugboat.isEmpty(transport.responseText)) return false;
          
          var json = eval('(' + transport.responseText + ')');
          Tugboat.gtd_task.sub_window.edit_task_onclick(json);
          Tugboat.gtd_task.progress.close();
        }
      }
    );
  },
  
  /**
   * clear add task values.
   * 
   */
  _clear_add_task_values : function() {
    $('task_description').value = '';
    $('task_tags').value = '';
    $('due_display').innerHTML = '';
    $('edit_due2').value = '';
  },
  
  /**
   * toggle add task option pane.
   * 
   * 
   */
  _toggle_add_task_option_pane : function() {
    Element.toggle('add_task_detail_table');
    Element.toggle('add_task_opt_show_link');
    Element.toggle('add_task_opt_hide_link');
  
    Tugboat.gtd_task._clear_add_task_values();
    Tugboat.gtd_common.resize_list_area(false,false);
    $('task_title').focus();
  
    $('add_task_option_toggle').className =
      $('add_task_detail_table').style.display == 'none' ? 'right_arrow' : 'down_arrow';
    
    if (Tugboat.gtd_task.task_group._task_group_selector_for_newtask) {
      Tugboat.gtd_task.task_group._task_group_selector_for_newtask.setSelectedId(-9);
    }   
  },
  
  /**
   * reload task list.
   */
  _reload_task_list : function() {
    if (Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_GTD.id) {
      Tugboat.gtd_task.folder.folder_onclick(Tugboat.gtd_task._before_selected_foder_id, true);
      
    } else if (Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_TAG.id) {
      Tugboat.gtd_task.tag._find_by_has_tags(0,1);
      
    } else if (Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_CAL.id) {
      Tugboat.gtd_task.calendar._get_tasks_by_due(0,1);
      
    } else if (Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_GROUP.id) {
      Tugboat.gtd_task.task_group._select_todo_by_group_id(
        Tugboat.gtd_task.task_group._selected_group.id,
        Tugboat.gtd_task.task_group._selected_group.name);
    }
  },
  
  /*
   * Sub window
   *
   * 
   */
  sub_window : {
    _task_sub_window       : null,
    _activity_selector1    : null,
    
    _tag_auto_completer1   : null,
    _tag_auto_completer2   : null,
    
    MODE_ADD  : 1,
    MODE_EDIT : 2,
    
    _editing_task       : null,
    _edit_mode          : 1,
    _is_processing      : false,
    
    ADD_TYPE_NORMAL  : 1,
    ADD_TYPE_ANOTHER : 2,
    
    /**
     * edit task onclick.
     * 
     * @param {Object} json
     */
    edit_task_onclick : function(json) {
      Tugboat.gtd_task.modal.open();
      
      var self = Tugboat.gtd_task.sub_window;
      self._edit_mode = self.MODE_EDIT;
      
      Element.hide('block_balloon');
      Element.show('add_task_option_tags');
      Element.hide('add_task_actions');
      Element.show('edit_task_actions');
      
      var task_group = Tugboat.gtd_task.task_group;
      if (task_group._current_new_group_mode != task_group._MODE_BY_EDIT) {
        self._activity_selector1.setSelectedId(json.task.activityId);
        self._editing_task = {
          id: json.task.id,
          statusId: json.task.statusId
        };
        $('add_task_title').value = json.task.title;
        $('add_task_description').value = json.task.description;
        $('edit_due_display1').innerHTML = json.task.dueFormated;
        $('edit_due1').value = json.task.dueValue;
        
        var tags = '';
        if (json.tags && json.tags.length > 0) {
          for (i = 0; i < json.tags.length; i++) {
            tags += (json.tags[i].tagValue + (i < json.tags.length - 1 ? ',' : ''));
          }
        }
        $('add_task_tags').value = tags;
        
        Tugboat.gtd_task.task_group._setup_select_menu_by_change_activity(
          Tugboat.gtd_task.task_group._task_group_selector_for_edittask, json.task.activityId);

        if (json.task.taskGroupId > 0) {
          Tugboat.gtd_task.task_group._task_group_selector_for_edittask.setSelectedId(json.task.taskGroupId);
        }
      }

      var height = Tugboat.gtd_task._is_ie6 ? 410 : 380;
      self._task_sub_window = 
        new Window(
          'addTaskWindow', 
          { className: 'mac_os_x', width:550, height:height, 
            zIndex: 100,
            minimizable: false,
            closable   : false,
            maximizable: false,
            resizable  : false,
            draggable  : true,
            title      : 'Edit task',
            showEffectOptions:{
              duration:0.3, 
              afterFinish:function(){
                $('add_task_title').focus();
              }
            }
          }
        );
      self._task_sub_window.setContent('task_sub_window_container',false,false);
      self._task_sub_window.setDestroyOnClose();
      self._task_sub_window.showCenter();
      var taskWindowObserver = {
        onDestroy: function(eventName, win) {
          if (win == self._task_sub_window) {
            Element.hide('task_sub_window_container');
            $('task_sub_window_container').appendChild($('addTaskForm'));
            
            self._task_sub_window = null;
            self._is_processing = false;
            Windows.removeObserver(this);
            
            if (task_group._current_new_group_mode != task_group._MODE_BY_EDIT) {
              $('add_task_title').value = '';
              $('add_task_description').value = '';
              $('edit_due_display1').innerHTML = '';
              $('edit_due1').value = '';
              $('add_task_tags').value = '';
            }
            self._tag_auto_completer1.hide();
            self._tag_auto_completer1.active = false;
            
            if (task_group._current_new_group_mode != task_group._MODE_BY_EDIT) {
              Tugboat.gtd_task.modal.close();
            }
          }
        }
      };
      Windows.addObserver(taskWindowObserver);
    },

    /**
     * setup auto completer for tags suggestion.
     * 
     */
    _setup_auto_completer : function() {
      var self = Tugboat.gtd_task.sub_window;
      self._tag_auto_completer1 = 
        new Ajax.Autocompleter(
          'add_task_tags_target',
          'add_task_tags_ac', 
          'teeda.ajax?component=taskTagAjax&action=findTagsByKeyword', 
          { minChars :1,
            paramName:'keyword',
            optionTextfield:$('selectedTagId_4ad'),
            optionAttributeName:'tgb:value',
            optionForJoinTextfield:$('add_task_tags')
          }
        );
        
      self._tag_auto_completer2 = 
        new Ajax.Autocompleter(
          'task_tags_target',
          'task_tags_ac', 
          'teeda.ajax?component=taskTagAjax&action=findTagsByKeyword', 
          { minChars :1,
            paramName:'keyword',
            optionTextfield:$('selected_tag_id'),
            optionAttributeName:'tgb:value',
            optionForJoinTextfield:$('task_tags')
          }
        );
    },
    
    /**
     * Add task.
     * 
     * @type [1:add, 2:add another]
     */
    add : function() {
      var self = Tugboat.gtd_task.sub_window;
      var selectActivityValue = Tugboat.gtd_task._add_task_activity_selector.getSelectValue();
      var activityId  = selectActivityValue ? selectActivityValue.id : null;
      var title       = $('task_title').value;
      var description = $('task_description').value;
      var tags        = $('task_tags').value;
      var due         = $('edit_due2').value;
      var groupId     = Tugboat.gtd_task.task_group._task_group_selector_for_newtask.getSelectValue().id;
      
      var is_overflow_tag_length = false;
      var tokens = tags.tokenize(',');
      tokens.each(
        function(t) {
          if (t.length > 64) {
            is_overflow_tag_length = true;
          }
        }
      );
      var messages = [];
      if (activityId == null)     messages.push('\'Activity\' is not selected.');
      if (Tugboat.isEmpty(title)) messages.push('\'Title\' is required.');
      if (is_overflow_tag_length) messages.push('\'Tag\' can input to 64 characters.');

      if (messages.length > 0) {
        Tugboat.showAlertDialog( messages );
        self._is_processing = false;
        return false;
      }

      //Tugboat.gtd_task.progress.open();
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        { 
          method: Tugboat.constant.REQUEST_POST,
          parameters:
          {
            component   : 'taskAjax',
            action      : 'add',
            activityId  : activityId,
            title       : title, 
            description : description,
            deadline    : due,
            tags        : tags,
            taskGroupId : groupId
          },
          onComplete: function(transport){
            $('task_title').value = '';
            $('task_title').focus();
            $('task_description').value = '';
            $('task_tags').value = '';
            $('task_tags_target').value = '';
            $('edit_due2').value = '';
            $('due_display').innerHTML = '';

            // update view.
            if (Tugboat.gtd_task._person_in_charge) { 
              Tugboat.gtd_task.browser._get_task_list_by_query_params(0,1);
            }
            else {
              var _task = Tugboat.gtd_task;
              new Ajax.Request (
                Tugboat.AJAX_SERVLET_NAME,
                {
                  method: Tugboat.constant.REQUEST_GET,
                  parameters:
                  {
                    component:'activityMemberAjax',
                    action:'getActivityMembersJSON'
                  },
                  onComplete: function(transport){
                    if (! transport.responseText) {
                      _task._person_in_charge = null;
                    }
                    else {
                      _task._person_in_charge = eval(transport.responseText);
                      _task.browser._create_person_in_charge_list(_task._person_in_charge);
                      _task.browser._get_task_list_by_query_params(0,1);
                    }
                  }
                }
              );
            }
            Tugboat.gtd_task.tag._setup_tag_folder(false);
            Tugboat.gtd_task.calendar._get_due_list();
            Tugboat.gtd_task.task_group._select_list();
          }
        }
      );
      return false;
    },
    
    /**
     * update.
     */
    update : function() {
      var self = Tugboat.gtd_task.sub_window;
      if (self._is_processing) return false;
      self._is_processing = true;
      
      var id = self._editing_task.id;
      var statusId = self._editing_task.statusId;
      
      var selectActivityValue = self._activity_selector1.getSelectValue();
      var activityId  = selectActivityValue ? selectActivityValue.id : null;
      var title       = $('add_task_title').value;
      var description = $('add_task_description').value;
      var tags        = $('add_task_tags').value;
      var due         = $('edit_due1').value;
      var groupId     = Tugboat.gtd_task.task_group._task_group_selector_for_edittask.getSelectValue().id;
      
      var messages = [];
      if (activityId == null)      messages.push('\'Activity\' is not selected.');
      if (Tugboat.isEmpty(title) ) messages.push('\'Title\' is required.');
      if (messages.length > 0) {
        Tugboat.showAlertDialog( messages );
        self._is_processing = false;
        return false;
      }
      
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        { 
          method: Tugboat.constant.REQUEST_POST,
          parameters:
          {
            component   : 'taskDetailAjax',
            action      : 'update',
            id          : id,
            statusId    : statusId,
            activityId  : activityId,
            title       : title, 
            description : description,
            deadline    : due,
            tags        : tags,
            taskGroupId : groupId
          },
          onComplete: function(transport){
            var json = eval('(' + transport.responseText + ')');
            var due_formated = 
              Tugboat.isEmpty(json.task.deadlineFormated)
              ? 'N/A'
              : json.task.deadlineFormated;

            Tugboat.gtd_common._before_selected_list_id = null;            
            $('task_list_block_title-' + id).innerHTML = json.task.title;
            $('task_list_due-' + id).innerHTML = due_formated;
            $('task_list_activity-' + id).className = 'activity_icon a_' + json.task.colorValue;
           
            Tugboat.gtd_task.tag._setup_tag_folder(false);
            Tugboat.gtd_task.calendar._get_due_list();
            Tugboat.gtd_task.task_group._select_list();
            Tugboat.gtd_task._reload_task_list();
            
            self._is_processing = false;
            Tugboat.gtd_task.modal.close();
          }
        }
      );
      Windows.closeAll();
      return false;
    },
    
    /**
     * Cancel task.
     * 
     */
    cancel : function() {
      Windows.closeAll();
    }
  },
  
  /*
   * Folder
   *
   * 
   */
  folder : {
    _CHECK_IMG_FILE_PATH_COMPLETE    : 'images/default/checkbox/task_complete.gif',
    _CHECK_IMG_FILE_PATH_NOTCOMPLETE : 'images/default/checkbox/task_notcomplete.gif',
    
    /**
     * set up classification.
     * 
     * @param {Object} id
     * @param {Object} before_selected_statuses
     * @param {Object} before_selected_classes
     */
    _setup_browse_classes : function(id, before_selected_statuses, before_selected_classes) {
      var self = Tugboat.gtd_task.folder;
      var browser = Tugboat.gtd_task.browser;
      var constants = Tugboat.constant.task;
      var classificationId = -1;

      TugboatUI.DragBox.drop_target_styles.each(
        function(folder) {
          //-- myself.
          if (id == folder.id) {
            $(id).className = folder.selectedStyle;
          
            $(constants.ID_LI_BROWSER_CLASS_LIST  + folder.value).style.display = Tugboat.constant.STYLE_DISPLAY_BLOCK;
            $(constants.ID_LI_BROWSER_CLASS_LIST  + folder.value).className = constants.CLASS_LIST_SELECT;
            $(constants.ID_IMG_BROWSER_CLASS_LIST + folder.value).src = self._CHECK_IMG_FILE_PATH_COMPLETE;
            
            browser._class_info[Number(folder.value)].checked = true;
            classificationId = folder.value;
          
            if (constants.FOLDER_INBOX.id != id) {
              $(constants.ID_LI_BROWSER_CLASS_LIST  + constants.FOLDER_INBOX.value).style.display = Tugboat.constant.STYLE_DISPLAY_NONE;
              $(constants.ID_LI_BROWSER_CLASS_LIST  + constants.FOLDER_INBOX.value).className = constants.CLASS_LIST_NOT_SELECT;
              $(constants.ID_IMG_BROWSER_CLASS_LIST + constants.FOLDER_INBOX.value).src = self._CHECK_IMG_FILE_PATH_NOTCOMPLETE;
            
              browser._class_info[constants.FOLDER_INBOX.value].checked = false;
            }
            if (constants.FOLDER_ARCHIVES.id != id) {
              $(constants.ID_LI_BROWSER_CLASS_LIST  + constants.FOLDER_ARCHIVES.value).style.display = Tugboat.constant.STYLE_DISPLAY_NONE;
              $(constants.ID_LI_BROWSER_CLASS_LIST  + constants.FOLDER_ARCHIVES.value).className = constants.CLASS_LIST_NOT_SELECT;
              $(constants.ID_IMG_BROWSER_CLASS_LIST + constants.FOLDER_ARCHIVES.value).src = self._CHECK_IMG_FILE_PATH_NOTCOMPLETE;
            
              browser._class_info[constants.FOLDER_ARCHIVES.value].checked = false;
            }
            if (constants.FOLDER_TRASH_BOX.id != id) {
              $(constants.ID_LI_BROWSER_CLASS_LIST  + constants.FOLDER_TRASH_BOX.value).style.display = Tugboat.constant.STYLE_DISPLAY_NONE;
              $(constants.ID_LI_BROWSER_CLASS_LIST  + constants.FOLDER_TRASH_BOX.value).className = constants.CLASS_LIST_NOT_SELECT;
              $(constants.ID_IMG_BROWSER_CLASS_LIST + constants.FOLDER_TRASH_BOX.value).src = self._CHECK_IMG_FILE_PATH_NOTCOMPLETE;
            
              browser._class_info[constants.FOLDER_TRASH_BOX.value].checked = false;
            }
          
          }
          //
          //-- inbox folder, archives folder, trash box folder.
          //
          else if (folder.value == constants.FOLDER_INBOX.value
                || folder.value == constants.FOLDER_ARCHIVES.value
                || folder.value == constants.FOLDER_TRASH_BOX.value) {
            $(folder.id).className = folder.defaultStyle;
          }
          //
          //-- class folder.
          //
          else if (folder.value < constants.FOLDER_INBOX.value) {
            $(folder.id).className = folder.defaultStyle;
            $(constants.ID_LI_BROWSER_CLASS_LIST  + folder.value).style.display = 
              (id == constants.FOLDER_ALL.id) 
              ? Tugboat.constant.STYLE_DISPLAY_BLOCK 
              : Tugboat.constant.STYLE_DISPLAY_NONE;
            
            if (id == constants.FOLDER_ALL.id && before_selected_classes) {
              if (before_selected_classes.length == 5) {
                $(constants.ID_LI_BROWSER_CLASS_LIST  + folder.value).className = constants.CLASS_LIST_NOT_SELECT;
                $(constants.ID_IMG_BROWSER_CLASS_LIST + folder.value).src = self._CHECK_IMG_FILE_PATH_NOTCOMPLETE;
                browser._class_info[Number(folder.value)].checked = false;
                
              } else {
                var cls = before_selected_classes.find(
                  function(c) {
                    return folder.value == c;
                  }
                );
                browser._class_info[0].checked = false;
                $(constants.ID_LI_BROWSER_CLASS_LIST  + constants.FOLDER_ALL.value).className = constants.CLASS_LIST_NOT_SELECT;
                $(constants.ID_IMG_BROWSER_CLASS_LIST + constants.FOLDER_ALL.value).src       = self._CHECK_IMG_FILE_PATH_NOTCOMPLETE;
                  
                $(constants.ID_LI_BROWSER_CLASS_LIST  + folder.value).className = 
                  (typeof(cls) == 'undefined' ? constants.CLASS_LIST_NOT_SELECT : constants.CLASS_LIST_SELECT);
                  
                $(constants.ID_IMG_BROWSER_CLASS_LIST + folder.value).src = 
                  (typeof(cls) == 'undefined' ? self._CHECK_IMG_FILE_PATH_NOTCOMPLETE : self._CHECK_IMG_FILE_PATH_COMPLETE);

                 browser._class_info[Number(folder.value)].checked = 
                   (typeof(cls) != 'undefined' && folder.value != constants.FOLDER_ALL.value);
              }
            } else {
              $(constants.ID_LI_BROWSER_CLASS_LIST  + folder.value).className = constants.CLASS_LIST_NOT_SELECT;
              $(constants.ID_IMG_BROWSER_CLASS_LIST + folder.value).src = self._CHECK_IMG_FILE_PATH_NOTCOMPLETE;
              browser._class_info[Number(folder.value)].checked = false;
            }
          }
        }
      );
      browser._is_plural_classes  = classificationId == 0;
      return classificationId;
    },
    
    /**
     * folder onclick
     * @param {Object} id
     * @param {Object} isReloadable
     * @param {Object} selectedBrowseInfo
     */
    folder_onclick : function(id, isReloadable, selectedBrowseInfo) {
      $('block_balloon').style.display=Tugboat.constant.STYLE_DISPLAY_NONE;

      $('add_task_pane').style.display =
        id == Tugboat.constant.task.FOLDER_INBOX.id
        ? Tugboat.constant.STYLE_DISPLAY_BLOCK
        : Tugboat.constant.STYLE_DISPLAY_NONE;

      if (Tugboat.isEmpty(id) ) id = Tugboat.gtd_task._before_selected_foder_id;
      if ($(id).className.indexOf('selected') > -1 && !isReloadable) return false; 

      if (Tugboat.gtd_task._current_mode > Tugboat.constant.task.SEL_MODE_GTD.id) {
        
        if (Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_CAL.id) {
          $('task_due_' + Tugboat.gtd_task.calendar._selected_due.due).className =
            Tugboat.gtd_task.calendar._selected_due.color + ' mouse_out';
          Tugboat.gtd_task.calendar._selected_due = null;

        } else if (Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_GROUP.id) {
          $('task_group-' + Tugboat.gtd_task.task_group._selected_group.id).className = 'mouse_out';
          $('task_group_edit_link').className = 'disable';
          $('task_group_more_link').className = 'disable';
          Tugboat.gtd_task.task_group._selected_group.id = -1;
          Tugboat.gtd_task.task_group._selected_group.name = '';
        }
        $('menuBar_browser').className = 'menuBar_browser';
        
        if (Tugboat.gtd_task._is_visibled_browser) {
           Element.show('browser_pane');
        }
        Tugboat.gtd_task._current_mode = Tugboat.constant.task.SEL_MODE_GTD.id;
      }

      // set selected folder info in view controller.
      var selectedFolder = Tugboat.constant.task.findFolderById(id);
      
      var current_folder_info_element = $('selected_folder_info');
      current_folder_info_element.innerHTML = '';
      current_folder_info_element.appendChild(SPAN(null, 'selected: '));
      current_folder_info_element.appendChild(STRONG(null, selectedFolder.name));

      //
      // tag folder to not selected.
      //
      $('selected_tags_container').className = 'selected_tags_off';
      
      // select folder.
      TugboatUI.DragBox.selected_folder_id = id;
      Tugboat.gtd_task._before_selected_foder_id = id;
      
      var self = Tugboat.gtd_task.folder;
      var browser = Tugboat.gtd_task.browser;
      var classificationId = 
        Tugboat.gtd_task.folder._setup_browse_classes(
          id,
          (selectedBrowseInfo ? selectedBrowseInfo.statuses : null),
          (selectedBrowseInfo ? selectedBrowseInfo.classes  : null)
        );

      TugboatUI.DragBox.drop_target_styles.each( function(droppable) {
        var folderStyle = TugboatUI.DragBox.find_folder_style(droppable.id);
        
        droppable.defaultStyle = 
          (droppable.id == classificationId)
            ? folderStyle.selectedStyle
            : folderStyle.defaultStyle;

        droppable.dragOverStyle = 
          (droppable.id == classificationId)
            ? folderStyle.selectedStyle
            : folderStyle.dragOverStyle;
      });
      browser._get_task_list_by_query_params(0, 1, true, selectedBrowseInfo);
    }
  },
  
  /*
   * Modal window
   *
   * 
   */
  modal : {
    _is_opened : false,
    
    open : function () {
      Tugboat.gtd_task.modal._is_opened = true;
      var page = Tugboat.getPageSize(); 
      Element.setHeight('modal_window', page.pageHeight);
      $('modal_window').style.display = Tugboat.constant.STYLE_DISPLAY_BLOCK;
      $('task_title').disabled = true;
    },

    close : function() {
      Tugboat.gtd_task.modal._is_opened = false;
      Element.hide('modal_window');
      $('task_title').disabled = false;
    }
  },
  
  /*
   * Progress
   *
   * 
   */
  progress : {
    _is_processing : false,
    
    open : function () {
      var self = Tugboat.gtd_task.progress;
      if (self._is_processing) return false;
      self._is_processing = true;
      
      var page = Tugboat.getPageSize(); 
      Element.setHeight('progress_window', page.pageHeight);
      $('progress_window').style.display = Tugboat.constant.STYLE_DISPLAY_BLOCK;
    },
    close : function() {
      Tugboat.gtd_task.progress._is_processing = false;
      Element.hide('progress_window');
    }
  },
  
  /*
   * Browser
   * 
   *  
   */
  browser : {
    _class_info    : [],
    _activity_info : [],
    _person_info   : [],
    _is_plural_classes : false,

    /**
     * create activity list.
     * @param {Object} json
     */
    _create_activity_list : function(json) {
      if (! json) return false;
      
      $('browser_list_activities').innerHTML = '';
      var ul= $('browser_list_activities');
      
      var activity_value = json.find(
        function(a) {
          return a.id == 0;
        }
      );
      var listAll = 
        LI({'id'    : 'browser_activity_list-0', 
            'class' : (activity_value.checked ?'list_select' : 'list_notselect')},
          [
            A({'id'      : 'browser_activity-0', 
               'class'   : 'button',
               'href'    : 'javascript:void(0);',
               'onclick' : Tugboat.gtd_task.browser.activity_onselect.bind(this, 0)},
              IMG(
                {'id'    : Tugboat.constant.task.ID_IMG_ACTIVITY_LIST + '0',
                 'border': '0',
                 'align' : 'absmiddle',
                 'src'   : (activity_value.checked 
                            ? 'images/default/checkbox/task_complete.gif'
                            : 'images/default/checkbox/task_notcomplete.gif')}),
                 'All'
            )
          ]
        );
      ul.appendChild(listAll);
      
      json.each(
        function(a) {
          if (a.id > 0) {
            var list = 
              LI({'id'    : Tugboat.constant.task.ID_LI_ACTIVITY_LIST + a.id, 
                  'class' : (a.checked ?'list_select' : 'list_notselect')},
                [
                  A({'id'      : 'browser_activity-'+a.id, 
                     'class'   : 'button',
                     'href'    : 'javascript:void(0);',
                     'onclick' : Tugboat.gtd_task.browser.activity_onselect.bind(this, a.id)},
                    IMG(
                      {'id'    : Tugboat.constant.task.ID_IMG_ACTIVITY_LIST + a.id,
                       'border': '0',
                       'align' : 'absmiddle',
                       'src'   : (a.checked 
                                  ? 'images/default/checkbox/task_complete.gif'
                                  : 'images/default/checkbox/task_notcomplete.gif')
                      }
                    ),
                    IMG({'border': '0',
                         'align' : 'absmiddle',
                         'class' : 'left_and_right_3px_margin',
                         'src'   : 'images/default/palette/sphere/pl_'+a.color + '_12x12.png'}),
                    a.value
                  )
                ]
              );
            ul.appendChild(list);
          }
        }
      );
    },
    
    /**
     * create person in charge list.
     * @param {Object} json
     */
    _create_person_in_charge_list : function(json) {
      if (! json) return false;
      
      $('browser_list_persons').innerHTML = '';
      var ul = $('browser_list_persons');
      
      json.each(
        function(p) {
          var list = 
            LI({'id'    : 'browser_person_list-' + p.id,
                 'class' : p.checked 
                           ? Tugboat.constant.task.CLASS_LIST_SELECT 
                           : Tugboat.constant.task.CLASS_LIST_NOT_SELECT},
              [
                A({'id'      : 'browser_person-' + p.id,
                   'class'   : 'button',
                   'href'    : 'javascript:void(0);',
                   'onclick' : Tugboat.gtd_task.browser.person_onselect.bind(this, p.id)},
                  IMG({'id'     : 'browser_person_list_img-' + p.id,
                       'border' : '0',
                       'align'  : 'align',
                       'src'    : p.checked ? 'images/default/checkbox/task_complete.gif'
                                            : 'images/default/checkbox/task_notcomplete.gif'}),
                  ' ' + p.last_name 
                      + (Tugboat.isEmpty(p.first_name) ? '' : (',' + p.first_name))
                )
              ]
            );
          ul.appendChild(list);
        }
      );
    },

    /**
     * reset browser.
     * @param {boolean} isReload
     */
    reset : function(isReload) {
      var self = Tugboat.gtd_task.browser;
      self._class_info = Tugboat.constant.task.get_default_classifications();
      
      if (isReload) {
        self._activity_info.each(
          function(a) {
            a.checked = a.id == 0;
            
            $('browser_activity_list-' + a.id).className = 
              (a.id == 0 ? 'list_select' : 'list_notselect');

            $(Tugboat.constant.task.ID_IMG_ACTIVITY_LIST + a.id).src = 
              (a.id == 0 ? 'images/default/checkbox/task_complete.gif'
                         : 'images/default/checkbox/task_notcomplete.gif');
          }
        );
      } else {
        self._activity_info = Tugboat.constant.task.get_default_activities();
      }

      $('browser_class_list_img-0').setAttribute('src','images/default/checkbox/task_complete.gif');
      $('browser_class_list-0').className = Tugboat.constant.task.CLASS_LIST_SELECT;

      $('browser_class_list_img-1').setAttribute('src','images/default/checkbox/task_notcomplete.gif');
      $('browser_class_list-1').className = Tugboat.constant.task.CLASS_LIST_NOT_SELECT;

      $('browser_class_list_img-2').setAttribute('src','images/default/checkbox/task_notcomplete.gif');
      $('browser_class_list-2').className = Tugboat.constant.task.CLASS_LIST_NOT_SELECT;

      $('browser_class_list_img-4').setAttribute('src','images/default/checkbox/task_notcomplete.gif');
      $('browser_class_list-4').className = Tugboat.constant.task.CLASS_LIST_NOT_SELECT;

      $('browser_class_list_img-5').setAttribute('src','images/default/checkbox/task_notcomplete.gif');
      $('browser_class_list-5').className = Tugboat.constant.task.CLASS_LIST_NOT_SELECT;

      $('browser_class_list_img-9').setAttribute('src','images/default/checkbox/task_notcomplete.gif');
      $('browser_class_list-9').className = Tugboat.constant.task.CLASS_LIST_NOT_SELECT;
    },
      
    /**
     * browser classification select.
     * 
     * @param {Object} classificationId
     */
    classification_onselect : function(classificationId) {
      var self = Tugboat.gtd_task.browser;
      if (!self._is_plural_classes) return false;
        
      //
      // set checkbox.
      //
      var classList = self._class_info;
      var isChecked = false;

      if (classList[classificationId]) {
        isChecked = classList[classificationId].checked;
      }
      var imageElement = 
        $(Tugboat.constant.task.ID_IMG_BROWSER_CLASS_LIST + classificationId);
          imageElement.setAttribute(
            'src',
            'images/default/checkbox/'
          + (isChecked ? 'task_notcomplete.gif' : 'task_complete.gif') );
        
      var listElement = 
        $(Tugboat.constant.task.ID_LI_BROWSER_CLASS_LIST + classificationId);

      listElement.className =
        isChecked 
        ? Tugboat.constant.task.CLASS_LIST_NOT_SELECT
        : Tugboat.constant.task.CLASS_LIST_SELECT;
      
      classList[classificationId] = {'id':classificationId,'checked':!isChecked};
        
      //
      // after proc.
      //
      var checkStatus = false;
      for (var i = 0; i < classList.length; i++) {
        if (classList[i] && classList[i].checked) {
          checkStatus = true;
          break;
        }
      }
      
      var checkAll = (!isChecked && classificationId ==0);
      if (!checkStatus) checkAll = true;
      
      classList[0] = {'id':0,'checked':checkAll};
        
      $(Tugboat.constant.task.ID_IMG_BROWSER_CLASS_LIST + '0').setAttribute(
        'src',
        'images/default/checkbox/' 
        + (checkAll ? 'task_complete.gif' : 'task_notcomplete.gif') );
            
      $(Tugboat.constant.task.ID_LI_BROWSER_CLASS_LIST + '0').className = 
        checkAll 
        ? Tugboat.constant.task.CLASS_LIST_SELECT 
        : Tugboat.constant.task.CLASS_LIST_NOT_SELECT;
          
      if (checkAll && checkStatus) {
        for (i = 0; i < classList.length; i++) {
          var elementId = Tugboat.constant.task.ID_IMG_BROWSER_CLASS_LIST + i;
          if (i==0 || !classList[i] || ! $(elementId)) continue;
          
          classList[i].checked = false;

          $(elementId).setAttribute(
            'src','images/default/checkbox/task_notcomplete.gif');

          $(Tugboat.constant.task.ID_LI_BROWSER_CLASS_LIST + i).className = 
            Tugboat.constant.task.CLASS_LIST_NOT_SELECT;
        }
      }
      self._get_task_list_by_query_params(0,1);
    },
      
    /**
     * browser activity select.
     * 
     * @param {Object} activityId
     */
    activity_onselect : function(activityId) {
      $('browser_activity-' + activityId).blur();

      // set checkbox.
      var self = Tugboat.gtd_task.browser;
      var activity_list = self._activity_info;
      var isChecked = false;
      
      var activity_value = activity_list.find(
        function(a) {
          return a.id == activityId;
        }
      );
      if (typeof(activity_value) != 'undefined' && activity_value) {
        isChecked = activity_value.checked;
        activity_value.checked = !activity_value.checked;
      }
      
      var imageElement = 
        $(Tugboat.constant.task.ID_IMG_ACTIVITY_LIST + activityId);
      imageElement.setAttribute(
        'src',
        'images/default/checkbox/'
          + (isChecked ? 'task_notcomplete.gif' : 'task_complete.gif') );
       
      var listElement = $(Tugboat.constant.task.ID_LI_ACTIVITY_LIST + activityId);
      listElement.className =
        isChecked 
        ? Tugboat.constant.task.CLASS_LIST_NOT_SELECT 
        : Tugboat.constant.task.CLASS_LIST_SELECT;
      
      // after proc.
      var checkActivity = false;
      for (var i = 0; i < activity_list.length; i++) {
        if (activity_list[i].checked) {
          checkActivity = true;
          break;
        }
      }
     
      var checkAll = (!isChecked && activityId == 0);
      if (!checkActivity) checkAll = true;
      
      $('browser_activity_list_img-0').setAttribute(
        'src',
        'images/default/checkbox/' 
        + (checkAll ? 'task_complete.gif' : 'task_notcomplete.gif') );
            
      $(Tugboat.constant.task.ID_LI_ACTIVITY_LIST + '0').className =
        checkAll
        ? Tugboat.constant.task.CLASS_LIST_SELECT
        : Tugboat.constant.task.CLASS_LIST_NOT_SELECT;
          
      if (checkAll && checkActivity) {
        activity_list.each(
          function(a) {
            if (a.id == 0) {
              a.checked = true;
            } else {
              a.checked = false;
              
              $(Tugboat.constant.task.ID_IMG_ACTIVITY_LIST + a.id).setAttribute(
                'src','images/default/checkbox/task_notcomplete.gif');
               $(Tugboat.constant.task.ID_LI_ACTIVITY_LIST + a.id).className = 
                 Tugboat.constant.task.CLASS_LIST_NOT_SELECT;
            }
          }
        );
      } else {
        var acitivity_value = activity_list.find(
          function(a) {
            return a.id == 0;
          }
        );
        acitivity_value.checked = false;
      }

      //
      // get person in charge.
      //
      var me = self._person_info.find(
        function(p) {
          return p.isMe;
        }
      );
      self._person_info = [];
      self._person_info.push(
        { 'id'        :me.id, 
          'checked'   :true,
          'isMe'      :me.isMe, 
          'last_name' :me.last_name,
          'first_name':me.first_name
        }
      );
      var self = Tugboat.gtd_task.browser;
      self._get_person_by_activities();
      self._get_task_list_by_query_params(0,1);
    },
    
    /**
     * get person by selected activities.
     */
    _get_person_by_activities : function() {
      var self = Tugboat.gtd_task.browser;
      var activityQueryParam = self._get_activity_query_params();
      
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        {
          method: Tugboat.constant.REQUEST_POST,
          parameters:
          {
            component   : 'activityMemberAjax',
            action      : 'getActivityMembersByActivities',
            activityIds : activityQueryParam
          },
          onComplete: function(transport){
            var json = eval(transport.responseText);
            var isExistChecked = false;
            self._person_info = [];
            json.each(
              function(p) {
                self._person_info.push(
                  { 'id'        :p.personId, 
                    'checked'   :p.isMe,
                    'isMe'      :p.isMe, 
                    'last_name' :p.personLastName,
                    'first_name':p.personFirstName
                  }
                );
              }
            );
            self._create_person_in_charge_list(self._person_info);
          }
        }
      );
    },
    
    /**
     * browser person in charge select. 
     * @param {Object} personId
     */
    person_onselect : function(personId) {
      $('browser_person-' + personId).blur();

      // set checkbox.
      var self = Tugboat.gtd_task.browser;
      var personList = self._person_info;
      var isChecked = false;
      var person_value = personList.find(
        function(p) {
          return p.id == personId;
        }
      );
      isChecked = person_value.checked;
      person_value.checked = !isChecked;

      var imageElement = $('browser_person_list_img-' + personId);
      imageElement.setAttribute(
        'src',
        'images/default/checkbox/'
          + (isChecked ? 'task_notcomplete.gif' : 'task_complete.gif') );
       
      var listElement = $('browser_person_list-' + personId);
      listElement.className =
        isChecked 
        ? Tugboat.constant.task.CLASS_LIST_NOT_SELECT 
        : Tugboat.constant.task.CLASS_LIST_SELECT;
      
      //
      // after proc.
      //
      var checkPerson = false;
      for (var i = 0; i < personList.length; i++) {
        if (personList[i].checked) {
          checkPerson = true;
          break;
        }
      }
      var checkAll = (!isChecked && personId == 0);
      if (!checkPerson) checkAll = true;
      
      $('browser_person_list_img-0').setAttribute(
        'src',
        'images/default/checkbox/' 
        + (checkAll ? 'task_complete.gif' : 'task_notcomplete.gif') );
      
      $('browser_person_list-0').className = 
        checkAll 
        ? Tugboat.constant.task.CLASS_LIST_SELECT 
        : Tugboat.constant.task.CLASS_LIST_NOT_SELECT;
        
      if (checkAll && checkPerson) {
        personList.each(
          function(a) {
            if (a.id == 0) {
              a.checked = true;
            } else {
              a.checked = false;
                 
              $('browser_person_list_img-' + a.id).setAttribute(
                'src','images/default/checkbox/task_notcomplete.gif');

              $('browser_person_list-' + a.id).className = 
                Tugboat.constant.task.CLASS_LIST_NOT_SELECT;
            }
          }
        );
      } else {
        var person_value = personList.find(
          function(a) {
            return a.id == 0;
          }
        );
        person_value.checked = false;
      }
      self._get_task_list_by_query_params(0,1);
    },
   
    /**
     * get class query params.
     * 
     */
    _get_class_query_params : function() {
      var self = Tugboat.gtd_task.browser;
      var classList = self._class_info;
      var classQueryParam = '';
      
      classList.each(
        function(c) {
          if (c && c.checked) { classQueryParam += c.id + ','; }
        }
      );
      if (TugboatUI.DragBox.selected_folder_id == Tugboat.constant.task.FOLDER_ARCHIVES.id) {
        classQueryParam = Tugboat.constant.task.CLASS_ARCHIVES.id;
      }
      else if (classQueryParam.length > 0) {
        classQueryParam = classQueryParam.substring(0,classQueryParam.length - 1);
      }
      return classQueryParam;
    },
    
    /**
     * get activity query params.
     * 
     */
    _get_activity_query_params : function() {
      var self = Tugboat.gtd_task.browser;
      var activityList = self._activity_info;
      var activityQueryParam = '';
      
      activityList.each(
        function(a) {
          if (a.checked) {
            activityQueryParam += a.id;
            activityQueryParam += ',';
          }
        }
      );
      if (activityQueryParam.length > 0) {
        activityQueryParam = activityQueryParam.substring(0,activityQueryParam.length - 1);
      }
      if (activityQueryParam == '0') activityQueryParam = '';
      return activityQueryParam;
    },
        
    /**
     * get person query params.
     * 
     */
    _get_person_query_params : function() {
      var self = Tugboat.gtd_task.browser;
      var library = Tugboat.gtd_task;
      var personList   = self._person_info;
      var personQueryParams = '';
      
      personList.each(
        function(p) {
          if (p.checked) {
            personQueryParams += p.id;
            personQueryParams += ',';
          }
        }
      );
      if (personQueryParams.length > 0) {
        personQueryParams = personQueryParams.substring(0,personQueryParams.length - 1);
      }
      if (personQueryParams == '0') {
        personQueryParams = '';
      }
      return personQueryParams;
    },
    
    /**
     * get task list by query params.
     * 
     * @param {Number}  offset
     * @param {Number}  currentPageNumber
     * @param {boolean} isFolderSelect
     * @param {Object}  selectedBrowseInfo
     */
    _get_task_list_by_query_params : function(
      offset, currentPageNumber, isFolderSelect, selectedBrowseInfo) {
      var self = Tugboat.gtd_task.browser;
      var library = Tugboat.gtd_task;
      
      TugboatUI.ActionSelector.destroy();
      
      var classQueryParam  = self._get_class_query_params();
      var selectFolderId = 
        Tugboat.constant.task.findFolderById(TugboatUI.DragBox.selected_folder_id).value;
      
      if (Tugboat.constant.task.CLASS_ALL.id == classQueryParam 
       && Tugboat.constant.task.FOLDER_ALL.id == TugboatUI.DragBox.selected_folder_id) {
          classQueryParam = 
          Tugboat.constant.task.CLASS_TODAY.id + ',' 
        + Tugboat.constant.task.CLASS_WEEK.id  + ','
        + Tugboat.constant.task.CLASS_MONTH.id + ','
        + Tugboat.constant.task.CLASS_HOLD.id  + ','
        + Tugboat.constant.task.CLASS_SOMEDAY.id;
      }
      
      if (!library._activities) return false;
      var activityQueryParam = self._get_activity_query_params();
      var personQueryParams  = self._get_person_query_params();
      
      Tugboat.gtd_task.progress.open();
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        {
          method: Tugboat.constant.REQUEST_GET,
          parameters:
          {
            component            :'taskAjax',
            action               :'getTaskListByQueryParams',
            queryStatusId        :'',
            queryClassificationId:classQueryParam,
            queryActivityId      :activityQueryParam,
            queryPersonId        :personQueryParams,
            selectFolderId       :selectFolderId,
            currentPageNumber    :currentPageNumber,
            offset               :offset,
            limit                :Tugboat.constant.ROWS_PER_PAGE
          },
          onComplete: function(transport){
            self._task_list_json = 
              Tugboat.gtd_common.create_list_dom(transport, Tugboat.gtd_common.FUNC_TYPE_TASK);

            if (navigator.userAgent.indexOf('MSIE 6.0') == -1
             && TugboatUI.DragBox.selected_folder_id == Tugboat.constant.task.FOLDER_INBOX.id) {
              $('task_title').focus();
             }
             
            //
            // set drag'n drop.
            //
            TugboatUI.DragBox.after_drag_drop['gtd'] = function(params){
              Tugboat.gtd_task.progress.open();
              new Ajax.Request(
                Tugboat.AJAX_SERVLET_NAME,
                {
                  method: Tugboat.constant.REQUEST_POST,
                  parameters:
                  {
                    component            :'taskAjax',
                    action               :'updateClassification',
                    params               :params,
                    limit                :Tugboat.constant.ROWS_PER_PAGE,
                    queryStatusId        :'',
                    queryClassificationId:classQueryParam,
                    queryActivityId      :activityQueryParam,
                    queryPersonId        :personQueryParams,
                    isViewStatusUpdate   :false,
                    taskGroupId          :(
                      TugboatUI.DragBox.selected_folder_id == Tugboat.constant.task.SEL_MODE_GROUP.label
                      ? Tugboat.gtd_task.task_group._selected_group.id
                      : 0)
                  },
                  onComplete: function(transport){
                    Tugboat.gtd_common.create_list_dom(transport, Tugboat.gtd_common.FUNC_TYPE_TASK);
                    Tugboat.gtd_task.calendar._get_due_list();
                    Tugboat.gtd_task.task_group._select_list();
                    Tugboat.gtd_task.progress.close();
                  }
                }
              );
            };
            Tugboat.gtd_task.progress.close();
          },
          onFailure : function(transport) {
            Tugboat.gtd_task.progress.close();
          }
        }
      );
    },
    
    /**
     * page navigation on click.
     * @param {Object} id
     */
    page_navi_onclick : function(id) {
      var element = $(id);
      if (element.className.indexOf('off') > -1) return false;
      
      var self = Tugboat.gtd_task.browser;
      var pageInfo = Tugboat.gtd_common.task.page_info;
      
      var num = id.indexOf('next') == -1 ? -1 : 1;
      var offset = 
        Tugboat.constant.ROWS_PER_PAGE * (pageInfo.currentPageNumber + num - 1);

      var currentPageNumber = 
        pageInfo.currentPageNumber + num;

      if (Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_GTD.id) {
        self._get_task_list_by_query_params(offset, pageInfo.currentPageNumber + num);

      } else if (Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_TAG.id) { 
        Tugboat.gtd_task.tag._find_by_has_tags(offset, pageInfo.currentPageNumber + num);

      } else {
        Tugboat.gtd_task.calendar._get_due_list(offset, pageInfo.currentPageNumber + num);
      }
    },
    
    /**
     * update classification.
     * 
     * @param {Object} task_id
     * @param {Object} status_id
     * @param {Object} class_id
     */
    update_classification : function(task_id, status_id, class_id) {
      var self = Tugboat.gtd_task.browser;
      var classQueryParam    = self._get_class_query_params();
      var activityQueryParam = self._get_activity_query_params();
      var personQueryParams  = self._get_person_query_params();

      if (classQueryParam == 0) {
        classQueryParam = '1,2,3,4,5';   
      }

      var params = '';
      params += '{"folderId":"' + class_id  + '",';
      params += ' "statusId":"' + status_id + '",';
      params += ' "params":[{"id":"' + task_id + '"}]}';

      var selected_tags_ids = Tugboat.gtd_task.tag._get_selected_tag_ids();
      var tag_ids = '';
      var due = '';
      var group_id = -1;
      
      // current - tag.
      if (TugboatUI.DragBox.selected_folder_id == Tugboat.constant.task.SEL_MODE_TAG.label
        && selected_tags_ids
        && selected_tags_ids.length > 0) {
        for (i = 0; i < selected_tags_ids.length; i++) {
          tag_ids += selected_tags_ids[i].tagId;
          tag_ids += (i == selected_tags_ids.length - 1 ? '' : ',');
        }
      }
      // current - calendar.
      else if (TugboatUI.DragBox.selected_folder_id == Tugboat.constant.task.SEL_MODE_CAL.label) {
        due =
          Tugboat.gtd_task.calendar._selected_due 
          ? Tugboat.gtd_task.calendar._selected_due.due
          : '';
      }
      // currnet - task-group.
      else if (TugboatUI.DragBox.selected_folder_id == Tugboat.constant.task.SEL_MODE_GROUP.label) {
        group_id = Tugboat.gtd_task.task_group._selected_group.id;
      }
      
      Tugboat.gtd_task.modal.open();
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        {
          method: Tugboat.constant.REQUEST_POST,
          parameters:
          {
            component             : 'taskAjax',
            action                : 'updateClassification',
            params                : params,
            limit                 : Tugboat.constant.ROWS_PER_PAGE,
            queryStatusId         : '',
            queryClassificationId : classQueryParam,
            queryActivityId       : activityQueryParam,
            queryPersonId         : personQueryParams,
            tagIdsString          : tag_ids,
            deadline              : due,
            taskGroupId           : group_id,
            isViewStatusUpdate    : false
          },
          onComplete: function(transport){
            Tugboat.gtd_common.create_list_dom(
              transport, Tugboat.gtd_common.FUNC_TYPE_TASK);

            Tugboat.gtd_task.calendar._get_due_list();
            Tugboat.gtd_task.task_group._select_list();
            Tugboat.gtd_task.modal.close();
          },
          onFailure : function(transport) {
            Tugboat.gtd_task.modal.close();
          }
        }
      );
    }
  },
  
  tag : {
    _current_task_id    : 0,
    _current_task_title : '',
    _edit_tags_window   : null,
    _own_tags           : null,
    _fileter_cond       : 1, // AND:1, OR:2
    
    /**
     * tag tab onclick.
     * @param 
     */
    tag_tab_onclick : function() {
      var tags_pane = $('tags_pane');
      if (tags_pane.style.display != 'none') return false;
      
      $('option_container').style.overflowX = 'hidden';
      $('option_container').style.overflowY = 'auto';
      
      $('calendar_pane').style.display = 'none';
      tags_pane.style.display = 'block';
      
      $('calendar_tab').className = 'calendar_tab';
      $('tags_tab').className = 'tags_tab_selected';
      
      $('task_group_pane').style.display = 'none';
      $('task_group_tab').className = 'task_group_tab';
      
      $('option_container').className = '';
      return false;
    },
    
    /**
     * tag onclick.
     * @param {Object} id
     */
    tag_onclick : function(id) {
      var self = Tugboat.gtd_task.tag;
      self._own_tags.each(
        function(t) {
          if (t.tagId == id) {
            Element.show('tag_selected-' + t.tagId);
            Element.hide('tag_not_selected-' + t.tagId);
            t.isSelected = true;
          } else {
            Element.hide('tag_selected-' + t.tagId);
            Element.show('tag_not_selected-' + t.tagId);
            t.isSelected = false;
          }
        }
      );
      self._find_by_has_tags(0,1);
      Element.show('selected_tags_container');
    },
    
    /**
     * find by has tags.
     *
     * @param {Object} offset
     * @param {Object} currentPageNumber
     */
    _find_by_has_tags : function(offset, currentPageNumber) {
      Tugboat.gtd_task.progress.open();
      
      if (Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_CAL.id) {
        $('task_due_' + Tugboat.gtd_task.calendar._selected_due.due).className =
          Tugboat.gtd_task.calendar._selected_due.color + ' mouse_out';
        Tugboat.gtd_task.calendar._selected_due = null;
  
      } else if (Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_GROUP.id) {
        $('task_group-' + Tugboat.gtd_task.task_group._selected_group.id).className = 'mouse_out';
        $('task_group_edit_link').className = 'disable';
        $('task_group_more_link').className = 'disable';
        Tugboat.gtd_task.task_group._selected_group.id = -1;
        Tugboat.gtd_task.task_group._selected_group.name = '';
      }
      Tugboat.gtd_task._current_mode = Tugboat.constant.task.SEL_MODE_TAG.id;
      TugboatUI.DragBox.selected_folder_id = 'tag';      
      
      if (! Tugboat.isEmpty(TugboatUI.DragBox.selected_folder_id)
       && TugboatUI.DragBox.selected_folder_id != 'calendar') {

        var folder_element = $(Tugboat.gtd_task._before_selected_foder_id);
        var clas_name = folder_element.className;
        folder_element.className = clas_name.replace(' selected','');
        
        TugboatUI.DragBox.selected_folder_id = Tugboat.constant.task.SEL_MODE_TAG.label;
      }
      
      $('selected_tags_container').className = 'selected_tags_on';
      
      var self = Tugboat.gtd_task.tag;
      var selected_tags_ids = self._get_selected_tag_ids();
      var tag_ids = '';
      
      if (selected_tags_ids && selected_tags_ids.length > 0) {
         var current_folder_info_element = $('selected_folder_info');
         current_folder_info_element.innerHTML = '';
        
        if (TugboatUI.DragBox.selected_folder_id == 'tag') {
          current_folder_info_element.appendChild(SPAN(null, 'selected: '));
        }
        for (i = 0; i < selected_tags_ids.length; i++) {
          tag_ids += selected_tags_ids[i].tagId;
          tag_ids += (i == selected_tags_ids.length - 1 ? '' : ',');
          
          current_folder_info_element.appendChild(
            STRONG(null, selected_tags_ids[i].tagValue));
          if (i < selected_tags_ids.length - 1) {
            current_folder_info_element.appendChild(SPAN(null, ', ') );
          }
        }
        Element.show('tag_selected_clear');
      } else {
        Element.hide('tag_selected_clear');
        Element.hide('selected_tags_container');
      }
      
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        { 
          method: Tugboat.constant.REQUEST_GET,
          parameters:
          {
            component         : 'taskAjax',
            action            : 'findTasksByHasTags',
            tagIdsString      : tag_ids,
            offset            : offset,
            limit             : Tugboat.constant.ROWS_PER_PAGE,
            currentPageNumber : currentPageNumber
          },
          onComplete: function(transport){
            Tugboat.gtd_common.create_list_dom(
              transport, Tugboat.gtd_common.FUNC_TYPE_TASK);

            Element.show('list_top_caption');
            Element.show('list_top');
            Element.show('list_middle_caption');
            Element.show('list_middle');
            Element.show('list_bottom_caption');
            Element.show('list_bottom');
            
            //
            // set drag'n drop.
            //
            TugboatUI.DragBox.after_drag_drop['gtd'] = function(params){
              new Ajax.Request(
                Tugboat.AJAX_SERVLET_NAME,
                {
                  method: Tugboat.constant.REQUEST_POST,
                  parameters:
                  {
                    component          : 'taskAjax',
                    action             : 'updateClassification',
                    params             : params,
                    limit              : Tugboat.constant.ROWS_PER_PAGE,
                    tagIdsString       : tag_ids,
                    isViewStatusUpdate : false
                  },
                  onComplete: function(transport){
                    Tugboat.gtd_common.create_list_dom(
                      transport, Tugboat.gtd_common.FUNC_TYPE_TASK);
                    Tugboat.gtd_task.task_group._select_list();
                  }
                }
              );
            };
            Tugboat.gtd_task.progress.close();
          },
          onFailure : function(transport) {
            Tugboat.gtd_task.progress.close();
          }
        }
      );
    },
    
    /**
     * get selected tag ids.
     */
    _get_selected_tag_ids : function() {
      var self = Tugboat.gtd_task.tag;
      var selected_tags_ids= [];
      
      if (self._own_tags) {
        self._own_tags.each(
          function(t) {
            if (t.isSelected == true) {
              selected_tags_ids.push(t);
            }
          }
        );
      }
      return selected_tags_ids;
    },
    
    /**
     * set up tag folder.
     * 
     * @param {boolean} initialize.
     */
    _setup_tag_folder : function(initialize) {
      var self = Tugboat.gtd_task.tag;
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        { 
          method: Tugboat.constant.REQUEST_GET,
          parameters:
          {
            component :'taskTagAjax',
            action    :'findByOwnTags'
          },
          onComplete: function(transport){
            if (Tugboat.isEmpty(transport.responseText)) {
              return false;
            }
            var selected_tags = [];
            if (self._own_tags) {
              self._own_tags.each(
                function(t) {
                  if (t.isSelected == true) {
                    selected_tags.push(t);
                  }
                }
              );
            }
            self._own_tags = eval(transport.responseText);
            var isExistsSelectedTag = false;
            
            if (self._own_tags) {
              var match_tags = [];
              self._own_tags.each(
                function(t) {
                  if (selected_tags) {
                    for (i=0; i<selected_tags.length; i++) {
                      if (t.tagId == selected_tags[i].tagId) {
                        t.isSelected = true;
                        isExistsSelectedTag = true;
                        
                        match_tags.push(t);
                      }
                    }
                  }
                }
              );
              
              if (match_tags) {
                var current_folder_info_element = $('selected_folder_info');
                if (TugboatUI.DragBox.selected_folder_id == 'tag') {
                  current_folder_info_element.innerHTML = '';
                  current_folder_info_element.appendChild(SPAN(null, 'selected: '));
                }

                if (Tugboat.gtd_task._before_selected_foder_id == '') {
                  i = 0;
                  match_tags.each(
                    function(t) {
                      current_folder_info_element.appendChild(STRONG(null, t.tagValue));
                      if (i < match_tags.length - 1) {
                        current_folder_info_element.appendChild(SPAN(null, ', ') );
                      }
                      i++;
                    }
                  );
                }
              }
            }
            if (!initialize && selected_tags
             && !isExistsSelectedTag
             && Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_GTD.id) {

              Tugboat.gtd_task.folder.folder_onclick(
                Tugboat.gtd_task._before_selected_foder_id, true);
            }
            self._create_dom_for_tag_folder(self._own_tags);
            self._create_dom_for_selected_tags(self._own_tags);
          }
        }
      );
    },
    
    /**
     * create dom for tag folder.
     * 
     * @param {Object} json
     */
    _create_dom_for_tag_folder : function(json) {
      var rootElement = $('not_selected_tags_container');
      rootElement.innerHTML = '';
      
      if (! json) return false;
      
      var self = Tugboat.gtd_task.tag;
      json.each(
        function(t) {
          var list =
            LI(
              { 
                'id':'tag_not_selected-' + t.tagId,
                'style':  t.isSelected == true ? 'display:none;' : 'display:block;',
                'onmouseover' : function() {
                  this.className = 'selected';
                },
                'onmouseout'  : function() {
                  this.className = 'drag_out';
                }
              },
              A({'href':'javascript:void(0);',
                 'class':'unselected',
                 'onclick':self._add_tag_onclick.bind(this,t.tagId)},
                t.tagValue
              )
            );
          rootElement.appendChild(list);
          new YAHOO.util.DDTarget('tag_not_selected-' + t.tagId, 'block');
        }
      );
    },
    
    /**
     * create dom for selected tags.
     * 
     * @param {Object} json
     */
    _create_dom_for_selected_tags : function(json) {
      var rootElement = $('selected_tags_container');
      rootElement.innerHTML = '';
      
      if (! json) return false;
      
      var self = Tugboat.gtd_task.tag;
      json.each(
        function(t) {
          var list =
            LI(
              {'id':'tag_selected-' + t.tagId, 
                'style':  t.isSelected == true ? 'display:block;' : 'display:none;',
                'onmouseover' : function() {
                  this.className = 'selected';
                  this.style.cursor = 'pointer';
                },
                'onmouseout' : function() {
                  this.className = 'drag_out';
                  this.style.cursor = 'default';
                }
              },
              
              A({ 'href':'javascript:void(0);',
                  'class':'selected',
                  'onclick': function() {
                    if (TugboatUI.DragBox.selected_folder_id =='tag' ) {
                      self._remove_tag_onclick(t.tagId);
                      
                    } else {
                      if (Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_CAL.id) {
                        $('task_due_' + Tugboat.gtd_task.calendar._selected_due.due).className =
                          Tugboat.gtd_task.calendar._selected_due.color + ' mouse_out';
                        Tugboat.gtd_task.calendar._selected_due = null;
              
                      } else if (Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_GROUP.id) {
                        $('task_group-' + Tugboat.gtd_task.task_group._selected_group.id).className = 'mouse_out';
                        $('task_group_edit_link').className = 'disable';
                        $('task_group_more_link').className = 'disable';
                        Tugboat.gtd_task.task_group._selected_group.id = -1;
                        Tugboat.gtd_task.task_group._selected_group.name = '';
                      }
                      Tugboat.gtd_task._current_mode = Tugboat.constant.task.SEL_MODE_TAG.id;
                      TugboatUI.DragBox.selected_folder_id = 'tag';

                      var folder_element = $(Tugboat.gtd_task._before_selected_foder_id);
                      var clas_name = folder_element.className;
                      folder_element.className = clas_name.replace(' selected','');

                      $('menuBar_browser').className = 'menuBar_browser_disable';
                      Element.hide('browser_pane');
                      Element.hide('add_task_pane');
                      
                      self._find_by_has_tags(0,1);
                    }
                    this.blur();
                  }
                },
                t.tagValue
              )
            );
          rootElement.appendChild(list);
          new YAHOO.util.DDTarget('tag_selected-' + t.tagId, 'block');
        }
      );
      rootElement.appendChild(
        LI(
          {'id':'tag_selected_clear', 'style':'display:none;'},
          A({ 'href':'javascript:void(0);',
              'onclick':'Tugboat.gtd_task.tag._remove_all();',
              'class':'clear_link'},'clear')
        )
      );
    },
    
    /**
     * add tag onclick.
     * 
     * @param {Number} id
     */
    _add_tag_onclick : function(id) {
      Element.hide('tag_not_selected-'+id);
      Element.show('tag_selected-'+id);
      
      var self = Tugboat.gtd_task.tag;
      tag_value = 
        self._own_tags.find(
          function(t) {
            return id == t.tagId; 
          }
        );
      tag_value.isSelected = true;
      $('selected_tags_container').style.display = 'block';
      
      self._find_by_has_tags(0,1);
    },
    
    /**
     * remove tag onclick.
     * 
     * @param {Object} id
     */
    _remove_tag_onclick : function(id) {
      Element.hide('tag_selected-'+id);
      Element.show('tag_not_selected-'+id);
      
      var self = Tugboat.gtd_task.tag;
      tag_value = 
        self._own_tags.find(
          function(t) {
            return id == t.tagId; 
          }
        );
      tag_value.isSelected = false;
      
      var isExists = 
        self._own_tags.find(
          function(t) {
            return t.isSelected == true; 
          }
        );
      
      if (typeof isExists != 'undefined') {
        self._find_by_has_tags(0,1);
      }
      else {
        Element.hide('tag_selected_clear');
        Element.hide('selected_tags_container');
        
        Tugboat.gtd_task._current_mode = Tugboat.constant.task.SEL_MODE_GTD.id;
        Tugboat.gtd_task.folder.folder_onclick(Tugboat.gtd_task._before_selected_foder_id, true);
      }
    },
    
    /**
     * remove all.
     * 
     */
    _remove_all : function() {
      var self = Tugboat.gtd_task.tag;
      self._own_tags.each(
        function(t) {
          Element.hide('tag_selected-'     + t.tagId);
          Element.show('tag_not_selected-' + t.tagId);
          t.isSelected = false;
        }
      );
      $('tag_filter').value = 'tags filter...';
      Element.hide('tag_selected_clear');
      Element.hide('selected_tags_container');
      
      Tugboat.gtd_task._current_mode = Tugboat.constant.task.SEL_MODE_GTD.id;
      Tugboat.gtd_task.folder.folder_onclick(Tugboat.gtd_task._before_selected_foder_id, true);
    },
    
    /**
     * setup tags drag target.
     * 
     */
    _setup_tags_drag_target : function() {
      TugboatUI.DragBox.after_drag_drop['tag'] = function(params, taskIds, tagId){
        new Ajax.Request(
          Tugboat.AJAX_SERVLET_NAME,
          { 
            method: Tugboat.constant.REQUEST_POST,
            parameters:
            {
              component            :'taskTagAjax',
              action               :'updateByDragnDrop',
              params               :params,
              isViewStatusUpdate   :false
            },
            onComplete: function(transport){
              if (Tugboat.isEmpty(transport.responseText)) return false;

              var taskTags = eval(transport.responseText);
              taskIds.each(
                function(t) {
                  var tag_values = '';
                  for (i = 0; i<taskTags.length; i++) {
                    if (taskTags[i].taskId == t) {
                      tag_values += 
                        taskTags[i].tagValue + (i < taskTags.length - 1 ? ', ' : '');
                    }
                  }
                  var tags_list  = $('gtd_tags_list-'  + t);
                  tags_list.innerHTML = '';
                  tags_list.appendChild(document.createTextNode(tag_values));
                  
                  var tags_block = $('gtd_tags_block-' + t);
                  tags_block.innerHTML = '';
                  tags_block.appendChild(document.createTextNode(tag_values));

                  new Effect.Highlight('gtd_list_' + t);
                }
              );
            }
          }
        );
      };
    }
  },

  /*
   * option - calendar
   *
   */
  calendar : {
    _selected_due : null,
    
    _get_due_list : function() {
      var self = Tugboat.gtd_task.calendar;
      
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        {
          method: Tugboat.constant.REQUEST_GET,
          parameters:
          {
            component:'taskAjax',
            action   :'getDueList'
          },
          onComplete: function(transport){
            $('calendar_list').innerHTML = '';

            if (Tugboat.isEmpty(transport.responseText)){
              self._selected_due = null;
              
              if (Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_GTD.id
               || Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_CAL.id) {
                Tugboat.gtd_task._current_mode = Tugboat.constant.task.SEL_MODE_GTD.id;
                Tugboat.gtd_task.folder.folder_onclick(Tugboat.gtd_task._before_selected_foder_id, true);
              }
              return false;
            }
            
            var icon_root_path = 'images/default/icon/';
            var ballet_red    = icon_root_path + (Tugboat.gtd_task._is_ie6 ? 'bullet_red.gif'    : 'bullet_red.png');
            var ballet_yellow = icon_root_path + (Tugboat.gtd_task._is_ie6 ? 'bullet_yellow.gif' : 'bullet_yellow.png');
            var ballet_green  = icon_root_path + (Tugboat.gtd_task._is_ie6 ? 'bullet_green.gif'  : 'bullet_green.png'); 
            
            var list = eval(transport.responseText);
            list.each(
              function(d) {
                var icon = d.color == 'red'    ? ballet_red    :
                           d.color == 'yellow' ? ballet_yellow :
                                                 ballet_green;
                var li =
                  LI({'id':'task_due_' + d.due, 'class':d.color},
                    [
                      IMG({'src':icon}),
                      P({'class':'date' }, d.due_formatted),
                      P({'class':'tasks'},(d.done_rows + ' / ' + d.total_rows))                  
                    ]
                  );
                $('calendar_list').appendChild(li);
              
                YAHOO.util.Event.addListener(
                  li, "mouseover",
                  function(e){
                    if (self._selected_due
                     && d.due == self._selected_due.due) {
                      return false;
                    }
                    li.style.cursor = 'pointer';
                    li.className = d.color + ' mouse_over';
                  },
                  false
                );
                YAHOO.util.Event.addListener(
                  li, "mouseout",
                  function(e){
                    if (self._selected_due
                     && d.due == self._selected_due.due) {
                      return false;
                    }
                    li.style.cursor = 'default';
                    li.className = d.color + ' mouse_out';
                  },
                  false
                );
                YAHOO.util.Event.addListener(
                  li, "click",
                  function(e){
                    if (self._selected_due) {
                      $('task_due_' + self._selected_due.due).className =
                        self._selected_due.color + ' mouse_out';
                    }
                    li.className = d.color + ' selected';
                    
                    Tugboat.gtd_task._current_mode = Tugboat.constant.task.SEL_MODE_CAL.id;
                    TugboatUI.DragBox.selected_folder_id = 'calendar';
                    
                    $('menuBar_browser').className = 'menuBar_browser_disable';
                    Element.hide('browser_pane');
                    Element.hide('add_task_pane');
                    Tugboat.gtd_common.resize_list_area(false,false);

                    var current_folder_info_element = $('selected_folder_info');
                    current_folder_info_element.innerHTML = '';
                    current_folder_info_element.appendChild(SPAN(null, 'selected: due : '));
                    current_folder_info_element.appendChild(STRONG(null, '[' + d.due_formatted + ']'));

                    var folder_element = $(Tugboat.gtd_task._before_selected_foder_id);
                    var clas_name = folder_element.className;
                    folder_element.className = clas_name.replace(' selected','');

                    $('selected_tags_container').className = 'selected_tags_off';

                    self._selected_due = d;
                    self._get_tasks_by_due(0,1);
                    
                    if (Tugboat.gtd_task.task_group._selected_group.id > 0) {
                      $('task_group-' + Tugboat.gtd_task.task_group._selected_group.id).className = 'mouse_out';
                      $('task_group_edit_link').className = 'disable';
                      $('task_group_more_link').className = 'disable';
                      Tugboat.gtd_task.task_group._selected_group.id = -1;
                      Tugboat.gtd_task.task_group._selected_group.name = '';
                    }
                  },
                  false
                );
              }
            );
            if (self._selected_due) {
              var target_element = $('task_due_' + self._selected_due.due);
              if (target_element) {
                target_element.className =
                  self._selected_due.color + ' selected';
              }
              self._get_tasks_by_due(0,1);
            }
          }
        }
      );
    },
  
    /**
     * get tasks by due.
     *
     * @param {Number} offset
     * @param {Number} current page number
     */
    _get_tasks_by_due : function(offset, currentPageNumber) {
      var self = Tugboat.gtd_task.calendar;
      if (! self._selected_due
       || ! $('task_due_' + self._selected_due.due)) {

        self._selected_due = null;
        Tugboat.gtd_task._current_mode = Tugboat.constant.task.SEL_MODE_GTD.id;
        Tugboat.gtd_task.folder.folder_onclick(
          Tugboat.gtd_task._before_selected_foder_id, true);

        return false;
      }
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        {
          method: Tugboat.constant.REQUEST_GET,
          parameters:
          {
            component : 'taskAjax',
            action    : 'getTasksByDue',
            deadline  : self._selected_due.due,
            offset            : offset,
            limit             : Tugboat.constant.ROWS_PER_PAGE,
            currentPageNumber : currentPageNumber
          },
          onComplete: function(transport){
            self._task_list_json = 
                Tugboat.gtd_common.create_list_dom(
                  transport, Tugboat.gtd_common.FUNC_TYPE_TASK);
          }
        }
      );
    }
  },
  
  /*
   * option - task group
   *
   */
  task_group : {
    _is_processing      : false,
    _activity_selector2 : null,
    _selected_group     : {'id':-1, 'name':''},
    _groups             : [],

    _task_group_selector_for_newtask  : null,
    _task_group_selector_for_edittask : null,
    _task_groups_for_selector         : [],
    _new_task_group_window            : null,
    _divide_task_window               : null,
    
    _current_new_group_mode : 0,  
    _MODE_BY_NEW_TASK       : 1,
    _MODE_BY_EDIT           : 2,
    
    _context_menu       : null,
    _divide_task_inputs : [],
    _js_obj_task_ids    : null,

    /**
     * task group tab onclick.
     */
    task_group_tab_onclick : function() {
      var task_group_pane = $('task_group_pane');
      if (task_group_pane.style.display != 'none') return false;

      $('option_container').style.overflowX = 'hidden';
      $('option_container').style.overflowY = 'hidden';
      
      $('task_group_pane').style.display = 'block';
      $('task_group_tab').className = 'task_group_tab_selected';

      $('tags_pane').style.display = 'none';
      $('tags_tab').className = 'tags_tab';
      
      $('calendar_pane').style.display = 'none';
      $('calendar_tab').className = 'calendar_tab';
      
      $('option_container').className = '';
      return false;
    },

    /**
     * new task group onclick
     * 
     * @param {Number} mode [1:by new task, 2:by edit]
     * @param {Object} task_group_object.
     */    
    new_task_group_onclick : function(mode, task_group_object) {
      Tugboat.gtd_task.modal.open();
      
      var self = Tugboat.gtd_task.task_group;
      self._current_new_group_mode = (typeof mode == "undefined" || mode == null ? 0 : mode);

      $('new_task_group_activity_container').style.display = mode ? 'none'  : 'block';
      $('new_task_group_activity_label').style.display     = mode ? 'block' : 'none';
    
      if (mode) {
        var selected_activity =
          mode == self._MODE_BY_NEW_TASK
          ? Tugboat.gtd_task._add_task_activity_selector.getSelectValue()
          : Tugboat.gtd_task.sub_window._activity_selector1.getSelectValue();

        $('new_task_group_activity_label').innerHTML = selected_activity.value;
        if (self._current_new_group_mode == self._MODE_BY_EDIT) {
          Windows.closeAll();
        }
      }

      var widow_title = task_group_object ? 'Edit task group' : 'New task group';
      if (task_group_object) {
        self._activity_selector2.setSelectedId(task_group_object.activityId);
        $('new_task_group_title').value = task_group_object.taskGroupName;
        $('new_task_group_description').value = task_group_object.description;

        var start_date = {'for_display':'', 'for_editor':''};
        if (task_group_object.startDate && task_group_object.startDate.length == 8) {
          var str_year  = task_group_object.startDate.substring(0,4);
          var str_month = task_group_object.startDate.substring(4,6);
          var str_day   = task_group_object.startDate.substring(6,8);

          start_date.for_display = str_year + '-' + str_month + '-' + str_day;
          start_date.for_editor = task_group_object.startDate;
        }
        $('new_task_group_start_display').innerHTML = start_date.for_display;
        $('new_task_group_start_edit').value        = start_date.for_editor;
        
        var deadline = {'for_display':'', 'for_editor':''};
        if (task_group_object.deadline && task_group_object.deadline.length == 8) {
          var str_year  = task_group_object.deadline.substring(0,4);
          var str_month = task_group_object.deadline.substring(4,6);
          var str_day   = task_group_object.deadline.substring(6,8);
          
          deadline.for_display = str_year + '-' + str_month + '-' + str_day;
          deadline.for_editor = task_group_object.deadline;
        }
        $('new_task_group_deadline_display').innerHTML = deadline.for_display;;
        $('new_task_group_deadline_edit').value        = deadline.for_editor;
      }
      
      var height = Tugboat.gtd_task._is_ie6 ? 370 : 345;
      self._new_task_group_window = 
        new Window(
          'newTaskGroupWindow', 
          { className: 'mac_os_x', width:550, height:height, 
            zIndex: 100,
            minimizable: false,
            closable   : false,
            maximizable: false,
            resizable  : false,
            draggable  : true,
            title      : widow_title,
            showEffectOptions:{
              duration:0.5, 
              afterFinish:function(){
                $('new_task_group_title').focus();
              }
            }
          }
        );
      self._new_task_group_window.display_mode = task_group_object ? 'edit' : 'new';
        
      var start_date =  $('new_task_group_start_edit');
      if (!task_group_object && start_date.value == '') {
        var now_date = Tugboat.getNowDateTime();
        
        $('new_task_group_start_display').innerHTML = 
          now_date.year
        + '-' + (now_date.month      < 10 ? '0' +  now_date.month      : now_date.month)
        + '-' + (now_date.dayOfMonth < 10 ? '0' +  now_date.dayOfMonth : now_date.dayOfMonth);
        
        $('new_task_group_start_edit').value =
          new String(now_date.year)
        + new String(now_date.month      < 10 ? '0' +  now_date.month      : now_date.month)
        + new String(now_date.dayOfMonth < 10 ? '0' +  now_date.dayOfMonth : now_date.dayOfMonth);
      }
      self._new_task_group_window.setContent('new_task_group_window_container',false,false);
      self._new_task_group_window.setDestroyOnClose();
      self._new_task_group_window.showCenter();
      
      var new_task_group_window_observer = {
        onDestroy: function(eventName, win) {
          if (win == self._new_task_group_window) {
            Element.hide('new_task_group_window_container');
            $('new_task_group_window_container').appendChild($('new_task_group_form'));
            
            self._new_task_group_window = null;
            self._is_processing = false;
            Windows.removeObserver(this);
            
            if (self._current_new_group_mode == self._MODE_BY_EDIT) {
              Tugboat.gtd_task.sub_window.edit_task_onclick(null);
              self._current_new_group_mode = 0;
            } else {
              Tugboat.gtd_task.modal.close();
            }
          }
        }
      };
      Windows.addObserver(new_task_group_window_observer);
    },
    
    /**
     * edit task group on click.
     * 
     */
    edit_task_group_onclick : function() {
      var self = Tugboat.gtd_task.task_group;
      var current_task_group_id = self._selected_group.id;
      
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        {
          method: Tugboat.constant.REQUEST_GET,
          parameters:
          {
            component   : 'taskGroupAjax',
            action      : 'findById',
            taskGroupId : current_task_group_id
          },
          onComplete: function(transport){
            if (Tugboat.isEmpty(transport.responseText)) return false;
            var js_obj = eval('(' + transport.responseText + ')');
            
            self.new_task_group_onclick(null, js_obj);
          }
        }
      );
    },

    /**
     * select task group list. 
     * 
     * @param {Number} added_group_id
     * @param {Function} callback_function
     */
    _select_list : function(added_group_id, callback_function){
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        {
          method: Tugboat.constant.REQUEST_GET,
          parameters:
          {
            component:'taskGroupAjax',
            action   :'select'
          },
          onComplete: function(transport){
            var js_obj =
              Tugboat.isEmpty(transport.responseText) ? null : eval(transport.responseText);

            Tugboat.gtd_task.task_group._create_view(js_obj);
            
            Tugboat.gtd_task.task_group._setup_select_menu(
              js_obj && js_obj.active ? js_obj.active : null, added_group_id);
            
            if (callback_function) callback_function();
          }
        }
      );
    },
    
    /**
     * create task group view.
     * @param {Object} task_groups
     */
    _create_view : function(task_groups) {
      if (! task_groups.active && ! task_groups.archive) return false;
      
      var self = Tugboat.gtd_task.task_group;
      self._groups = [];
      self._generate_dom(task_groups.active, $('task_group_list'), false);
      self._generate_dom(task_groups.archive, $('task_group_archive_pane'), true);
    },
    
    /**
     * generate task group dom.
     * 
     * @param {Object} groups
     * @param {Object} task_group_dom
     * @param {Object} is_archives
     */
    _generate_dom : function(groups, task_group_dom, is_archives) {
      var self = Tugboat.gtd_task.task_group;
      task_group_dom.innerHTML = '';

      if (!groups) return false;
      groups.each(
        function(t) {
          var div_activity_id  = 'task_group_activity_' + (is_archives ? 'archive-' : 'active-') +  t.activityId;
          var ul_group_id      = 'task_group_list_'     + (is_archives ? 'archive-' : 'active-') +  t.activityId;
          var p_total_tasks_id = 'total_tasks_'         + (is_archives ? 'archive-' : 'active-') +  t.activityId;

          var div_activity =
            DIV({
              'id':div_activity_id,
              'class':'expand',
              'onclick' : function() {
                  this.className = this.className == 'expand' ? 'collapse' : 'expand';
                  $(ul_group_id).style.display = this.className == 'collapse' ? 'none' : 'block'; 
                  this.blur();
                },
              'onmouseover': function() { this.style.cursor = 'pointer'; },
              'onmouseout' : function() { this.style.cursor = 'default'; }
              },
              [
                P({'class':'a_' + t.activityColor},t.activityName),
                P({'class':'total_tasks', 'id':p_total_tasks_id}, '')
              ]
            );
          task_group_dom.appendChild(div_activity);
          
          var div_task_group_list_container = DIV({'id':ul_group_id});
          task_group_dom.appendChild(div_task_group_list_container);

          if (!t.taskGroups) {
          } else {
            var pages = 
              is_archives && t.taskGroups && t.taskGroups.length > 0
              ? Math.floor(t.taskGroups.length / Tugboat.constant.OPTION_AREA_ROWS_PER_PAGE)
                + (t.taskGroups.length % Tugboat.constant.OPTION_AREA_ROWS_PER_PAGE > 0 ? 1 : 0)
              : 1;

            var rows = 1;
            var sum_tasks = 0;
            var before_page_number = 0;
            var ul_task_group = null;

            t.taskGroups.each(
              function(g) {
                var page_number = pages == 1
                  ? 1
                  : Math.ceil(rows / Tugboat.constant.OPTION_AREA_ROWS_PER_PAGE);
                
                if (before_page_number != page_number) {
                  if (page_number > 1) {
                    var navi_list = LI({'class':'task_group_archive_navi'});
                    self._create_archive_page_navi(ul_group_id, navi_list, pages, before_page_number);
                    ul_task_group.appendChild(navi_list);

                    div_task_group_list_container.appendChild(ul_task_group);
                  }
                  ul_task_group = 
                    UL({
                      'id':ul_group_id + '_' + page_number,
                      'class':'task_group_list',
                      'style':'display:' + (page_number == 1 ? 'block' : 'none')
                    });
                }
                sum_tasks += g.all;
                
                var list_id = 'task_group-' + g.id;
                self._groups.push({
                  'id'         :list_id,
                  'activity_id':g.activityId,
                  'group_id'   :g.id,
                  'is_archive' :is_archives
                });
                
                var li_group = 
                  LI({
                    'id':list_id, 
                    'class': (g.id == self._selected_group.id ? 'selected' : '') 
                  });
                var p_name  = P({'class':'task_group_label'}, g.name);
                var p_tasks = P({'class':'tasks'}, is_archives ? ('[' + g.all + ']') : (g.done + ' / ' + g.all));
                
                li_group.appendChild(p_name);
                li_group.appendChild(p_tasks);
                ul_task_group.appendChild(li_group);

                new YAHOO.util.DDTarget(list_id, 'block');
                
                YAHOO.util.Event.addListener(
                  li_group, "mouseover",
                  function(e){
                    if (self._selected_group.id == g.id) return false;
                    
                    li_group.style.cursor = 'pointer';
                    li_group.className = 'mouse_over';
                  },
                  false
                );
                YAHOO.util.Event.addListener(
                  li_group, "mouseout",
                  function(e){
                    if (self._selected_group.id == g.id) return false;
                    
                    li_group.style.cursor = 'default';
                    li_group.className = 'mouse_out';
                  },
                  false
                );
                YAHOO.util.Event.addListener(
                  li_group, "click",
                  function(e){
                    if (self._selected_group.id == g.id) return false;
                    if (self._selected_group.id > 0) {
                      $('task_group-' + self._selected_group.id).className = 'default';
                    }
                    li_group.className = 'selected';
                    self._selected_group = {
                      'id'  : g.id,
                      'name': g.name
                    };
                    self._select_todo_by_group_id(g.id, g.name);
                    
                    if (self._selected_due) {
                      $('task_due_' + self._selected_due.due).className =
                        self._selected_due.color + ' mouse_out';
                      self._selected_due = null;
                    }
                    $('task_group_edit_link').className = 'enable';
                    $('task_group_more_link').className = 'enable';
                  }
                );
                before_page_number = page_number;
                rows++;
              }
            );
            $(p_total_tasks_id).innerHTML = sum_tasks;
            
            if (before_page_number > 1) {
              var navi_list = LI({'class':'task_group_archive_navi'});
              self._create_archive_page_navi(ul_group_id, navi_list, pages, before_page_number);
              ul_task_group.appendChild(
                navi_list
              );
            }

            div_task_group_list_container.appendChild(ul_task_group);
          }
        }
      );
    },
    
    /**
     * create archive page navi.
     * 
     * @param {Object} target_dom
     * @param {Object} pages
     * @param {Object} page_number
     */
    _create_archive_page_navi : function(root_dom, target_dom, pages, page_number) {
      target_dom.appendChild(SPAN ({'style':'color:#888;'}, page_number + '/' +  pages + ' page'));
      var is_safari = self._is_ie6 = navigator.userAgent.indexOf('Safari') > -1;
      
      if (page_number == 1) {
        target_dom.appendChild(
          A({
            'id'    : 'task_group_archive_page_navi_prev',
            'class' : (is_safari ? '' : 'next_navi'),
            'onclick': Tugboat.gtd_task.task_group._archive_page_navi.bind(this, root_dom, page_number, 1)
            }, function(){
              return is_safari ? ' next >' : SPAN(null, ' ');
            }
          )
        );

      } else if (page_number > 1 && page_number < pages) {
        target_dom.appendChild(
          A({
            'class' : (is_safari ? '' : 'prev_navi'),
            'onclick': Tugboat.gtd_task.task_group._archive_page_navi.bind(this, root_dom, page_number, -1)
            }, function(){
              return is_safari ? ' < prev ' : SPAN(null, ' ');
            }
          )
        );
        target_dom.appendChild(
          A({
            'class' : (is_safari ? '' : 'next_navi'),
            'onclick': Tugboat.gtd_task.task_group._archive_page_navi.bind(this, root_dom, page_number, 1)
            }, function(){
              return is_safari ? ' next >' : SPAN(null, ' ');
            }
          )
        );

      } else {
        target_dom.appendChild(
          A({
            'class' : (is_safari ? '' : 'prev_navi'),
            'onclick': Tugboat.gtd_task.task_group._archive_page_navi.bind(this, root_dom, page_number, -1)
            }, function(){
              return is_safari ? ' < prev ' : SPAN(null, ' ');
            }
          )
        );
      }
    }, 
    
    /**
     * archive page navi.
     * 
     * @param {String} root_dom_id
     * @param {Object} current_page_number
     * @param {Number} navi
     */
    _archive_page_navi : function(root_dom_id, current_page_number, navi) {
      Element.hide(root_dom_id + '_' + current_page_number);
      Element.show(root_dom_id + '_' + (current_page_number + navi));
    },
    
    /**
     * setup select menu.
     * 
     * @param {Object} task_groups
     * @param {Number} added_group_id
     */
    _setup_select_menu : function(task_groups, added_group_id) {
      var self = Tugboat.gtd_task.task_group;
      self._task_groups_for_selector = [];
      self._task_groups_for_selector.push({'id':-9, 'value':'--------',            'icon':'images/default/icon/space.gif'});
      self._task_groups_for_selector.push({'id':-1, 'value':'[New Task Group...]', 'icon':'images/default/icon/space.gif'});
      
      if (task_groups) {
        task_groups.each(function(t){
          t.taskGroups.each(function(g){
            self._task_groups_for_selector.push({
              'id': g.id,
              'value': g.name,
              'activity_id': t.activityId,
              'icon': 'images/default/icon/bullet_green.gif'
            });
          });
        });
      }
      
      if (added_group_id) {
        var activity_id = 
          self._current_new_group_mode == 1
            ? Tugboat.gtd_task._add_task_activity_selector.getSelectValue().id
            : Tugboat.gtd_task.sub_window._activity_selector1.getSelectValue().id;
        
        var selector = 
          self._current_new_group_mode == self._MODE_BY_NEW_TASK
          ? Tugboat.gtd_task.task_group._task_group_selector_for_newtask
          : Tugboat.gtd_task.task_group._task_group_selector_for_edittask;
        
        self._setup_select_menu_by_change_activity(selector,activity_id);
        selector.setSelectedId(added_group_id);

      } else {
        if (Tugboat.gtd_task.task_group._task_group_selector_for_newtask == null) {
          Tugboat.gtd_task.task_group._task_group_selector_for_newtask =
            new TugboatUI.SelectMenu(
              'task_group_container_for_newtask', [], {
                parentElement: 'content',
                isParentWindow: false,
                onSelected: function(selectValue){
                  self._task_group_list_on_select(self._MODE_BY_NEW_TASK, selectValue);
                }
              });
        }
        if (Tugboat.gtd_task.task_group._task_group_selector_for_edittask == null) {
          Tugboat.gtd_task.task_group._task_group_selector_for_edittask =
            new TugboatUI.SelectMenu('task_group_container_for_edittask', [], {
              parentElement: 'addTaskWindow',
              isParentWindow: true,
              onSelected: function(selectValue){
                self._task_group_list_on_select(self._MODE_BY_EDIT, selectValue);
              }
            });
        }
      }
    },
    
    /**
     * task group list on select.
     * 
     * @param {Number} mode
     * @param {Object} value
     */
    _task_group_list_on_select : function(mode, value) {
      switch(value.id) {
        // n/a
        case -9:
          break;
        // new task group.
        case -1:
          Tugboat.gtd_task.task_group.new_task_group_onclick(mode);
          break;
        // selected task group.
        default:
          break;
      }
    },
    
    /**
     * setup select menu by change activity.
     * 
     * @param {Object} selector
     * @param {Number} select_activity_id
     */
    _setup_select_menu_by_change_activity : function(selector, select_activity_id) {
      var list = [];
      Tugboat.gtd_task.task_group._task_groups_for_selector.each(
        function(g) {
          if (g.id == -9 || g.id == -1 || select_activity_id == g.activity_id) {
            list.push({'id':g.id, 'value':g.value, 'icon':g.icon});
          }
        }
      );
      selector.setListItems(list); 
    },
    
    /**
     * find group by dom-id. for ui.dnd
     * @param {Object} dom_id
     */
    _find_group_by_dom_id : function(dom_id) {
      var self = Tugboat.gtd_task.task_group;
      if (! self._groups) return null;
      
      var group = null;
      for (var i=0; i<self._groups.length; i++) {
        if (dom_id == self._groups[i].id) {
          group = self._groups[i];
          break;
        }
      }
      return group;
    },
    
    /**
     * select todo by task group id.
     * 
     * @param {Object} task_group_id
     */
    _select_todo_by_group_id : function(task_group_id, task_group_name) {
      Tugboat.gtd_task.progress.open();
      
      var self = Tugboat.gtd_task.task_group;
      self._selected_group.id = task_group_id;
      self._selected_group.name = task_group_name;
      
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        {
          method: Tugboat.constant.REQUEST_GET,
          parameters:
          {
            component   : 'taskAjax',
            action      : 'getTasksByTaskGroupId',
            taskGroupId : task_group_id
          },
          onComplete: function(transport){
            TugboatUI.DragBox.selected_folder_id = 'group';
            Tugboat.gtd_task._current_mode = Tugboat.constant.task.SEL_MODE_GROUP.id;
            TugboatUI.DragBox.selected_folder_id = Tugboat.constant.task.SEL_MODE_GROUP.label;
            
            // TO DO selected > default.
            $('menuBar_browser').className = 'menuBar_browser_disable';
            Element.hide('browser_pane');
            Element.hide('add_task_pane');
            Tugboat.gtd_common.resize_list_area(false,false);
            
            var folder_element = $(Tugboat.gtd_task._before_selected_foder_id);
            var className = folder_element.className;
            folder_element.className = className.replace(' selected','');
            
            $('task_group-' + task_group_id).className = 'selected';
            $('task_group_edit_link').className = 'enable';
            $('task_group_more_link').className = 'enable';
            
            for (var i=0; i<self._groups.length; i++) {
              if (task_group_id == self._groups[i].group_id) {
                
                if (self._groups[i].is_archive) self.archive_tab_onclick();
                else                            self.active_tab_onclick();
                break;
              }
            }
           
            // Create DOM.
            Tugboat.gtd_common.create_list_dom(transport, Tugboat.gtd_common.FUNC_TYPE_TASK);
            
            // set current folder info.
            var current_folder_info_element = $('selected_folder_info');
            current_folder_info_element.innerHTML = '';
            current_folder_info_element.appendChild(SPAN(null, 'selected: Task-Group : '));
            current_folder_info_element.appendChild(STRONG(null, '[' + task_group_name + ']'));
            
            Tugboat.gtd_task.progress.close();
          }
        }
      );
    },
    
    /**
     * setup task group drag target.
     */
    _setup_task_group_drag_target : function() {
      TugboatUI.DragBox.after_drag_drop['group'] = function(params, task_ids, group_id){        
        new Ajax.Request(
          Tugboat.AJAX_SERVLET_NAME,
          { 
            method: Tugboat.constant.REQUEST_POST,
            parameters:
            {
              component            :'taskGroupAjax',
              action               :'updateByDragnDrop',
              params               :params,
              isViewStatusUpdate   :false
            },
            onComplete: function(transport){
              if (Tugboat.isEmpty(transport.responseText)) return false;
              // reflesh task group list.
              var js_obj = eval(transport.responseText);
              Tugboat.gtd_task.task_group._create_view(js_obj);
              
              // reflesh task list.
              Tugboat.gtd_task._reload_task_list();
            }
          }
        );
      };
    },
    
    /**
     * get input values.
     * @return {Object} input_values 
     */
    _get_input_values : function() {
      var self = Tugboat.gtd_task.task_group;
      var input_values = {};
      
      input_values.activity_id = 
        self._current_new_group_mode == 0
        ? self._activity_selector2.getSelectValue()
        : self._current_new_group_mode == 1
          ? Tugboat.gtd_task._add_task_activity_selector.getSelectValue()
          : Tugboat.gtd_task.sub_window._activity_selector1.getSelectValue();
      
      input_values.title = $('new_task_group_title').value;
      input_values.description = $('new_task_group_description').value;
      input_values.start_date = $('new_task_group_start_edit').value;
      input_values.deadline = $('new_task_group_deadline_edit').value;
      
      var messages = [];
      if (self._current_new_group_mode == 0 
        && (input_values.activity_id == null || input_values.activity_id == 0)) {
        messages.push('\'Activity\' is not selected.');
      }
      if (Tugboat.isEmpty(input_values.title)) {
        messages.push('\'Title\' is required.');
      }
      if (!Tugboat.isEmpty(input_values.deadline) && input_values.deadline < input_values.start_date ) {
        messages.push('\'Deadline\' is after start date.');
      }
      input_values.messages = messages;
      return input_values;
    },
    
    /**
     * add task group.
     */
    _add : function() {
      var self = Tugboat.gtd_task.task_group;
      if (self._is_processing) return false;
      
      var input_values = self._get_input_values();
      if (input_values.messages.length > 0) {
        Tugboat.showAlertDialog(input_values.messages);
        return false;
      }
      self._is_processing = true;

      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        { 
          method: Tugboat.constant.REQUEST_POST,
          parameters:
          {
            component   : 'taskGroupAjax',
            action      : 'add',
            activityId  : input_values.activity_id.id,
            title       : input_values.title, 
            description : input_values.description,
            startDate   : input_values.start_date,
            deadline    : input_values.deadline
          },
          onComplete: function(transport){
            var jsobj = eval(transport.responseText);
            
            self._is_processing = false;
            self._select_list(jsobj.id);
            self._clear();
                        
          }
        }
      );
      Windows.closeAll();
    },
    
    /**
     * clear values.
     */
    _clear : function() {
      $('new_task_group_title').value = '';
      $('new_task_group_description').value = '';
      $('new_task_group_start_display').innerHTML = '';
      $('new_task_group_start_edit').value = '';
      $('new_task_group_deadline_display').innerHTML = '';
      $('new_task_group_deadline_edit').value = '';
    },
    
    /**
     * update task group.
     */
    _update : function() {
      var self = Tugboat.gtd_task.task_group;
      if (self._is_processing) return false;
      
      var input_values = self._get_input_values();
      if (input_values.messages.length > 0) {
        Tugboat.showAlertDialog(input_values.messages);
        return false;
      }
      self._is_processing = true;

      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        { 
          method: Tugboat.constant.REQUEST_POST,
          parameters:
          {
            component   : 'taskGroupAjax',
            action      : 'update',
            taskGroupId : self._selected_group.id,
            activityId  : input_values.activity_id.id,
            title       : input_values.title,
            description : input_values.description,
            startDate   : input_values.start_date,
            deadline    : input_values.deadline
          },
          onComplete: function(transport){
            self._is_processing = false;
            self._select_list(self._selected_group.id);
            self._select_todo_by_group_id(
              Tugboat.gtd_task.task_group._selected_group.id,
              Tugboat.gtd_task.task_group._selected_group.name);
            self._clear();
          }
        }
      );
      Windows.closeAll();
    },
    
    /**
     * delete task group.
     */
    _delete : function () {
      var self = Tugboat.gtd_task.task_group;
      if ( !confirm('May I remove \'' + self._selected_group.name + '\' ?') ) return false;
      
      Tugboat.gtd_task.modal.open();
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        { 
          method: Tugboat.constant.REQUEST_POST,
          parameters:
          {
            component   : 'taskGroupAjax',
            action      : 'delete',
            taskGroupId : self._selected_group.id
          },
          onComplete: function(transport){
            var callback_function = function() {
              var group_id = 0;
              var group_name = '';
              
              if (self._task_groups_for_selector) {
                for (var i=0; i<self._task_groups_for_selector.length; i++) {
                  if (self._task_groups_for_selector[i].id > 0) {
                    group_id = self._task_groups_for_selector[i].id;
                    group_name = self._task_groups_for_selector[i].value;
                    break;
                  }
                }  
              }
              self._selected_group.id = group_id;
              self._selected_group.name = group_name;
              
              if (group_id > 0) {
                self._select_todo_by_group_id(self._selected_group.id, self._selected_group.name);
              } else {
                Tugboat.gtd_task._current_mode = Tugboat.constant.task.SEL_MODE_GTD.id;
                Tugboat.gtd_task.folder.folder_onclick(Tugboat.gtd_task._before_selected_foder_id, true);
              }
            }
            self._select_list(null, callback_function);
            self._clear();
            Tugboat.gtd_task.modal.close();
          }
        }
      );
    },
    
    /**
     *setup context menu.
     */
    _setup_context_menu: function(){
      var self = Tugboat.gtd_task.task_group;
      if (self._context_menu) return false;
      
      self._context_menu = new TugboatUI.ActionSelector({
        uid : Tugboat.constant.task.UID_GROUP_CONTEXT_MENU,
        root_element         : 'task_group_pane',
        link_element_on_img  : 'images/default/icon/space.gif',
        link_element_off_img : 'images/default/icon/space.gif',
        on_selected : function(task_id, action_id) {
          switch (action_id) {
            case Tugboat.constant.task.MENU_ID_GRP_DELETE:
              self._delete();
              break;
            case Tugboat.constant.task.MENU_ID_TEMP_NEW:
              break;
            case Tugboat.constant.task.MENU_ID_TEMP_OPEN:
              break;
            case Tugboat.constant.task.MENU_ID_TEMP_SAVE:
              break;
            case Tugboat.constant.task.MENU_ID_TEMP_EDIT:
              break;
          }
        }
      });
      self._context_menu.items = Tugboat.constant.task.GROUP_CONTEXT_MENU_ITEMS;
    },
    
    active_tab_onclick : function() {
      $('task_group_active_pane').style.display = 'block';
      $('task_group_menu_tab_active').className = 'enable';
      $('task_group_archive_pane').style.display = 'none';
      $('task_group_menu_tab_archives').className = 'disable';
    },
    
    archive_tab_onclick : function() {
      $('task_group_active_pane').style.display = 'none';
      $('task_group_menu_tab_active').className = 'disable';
      $('task_group_archive_pane').style.display = 'block';
      $('task_group_menu_tab_archives').className = 'enable'; 
    },
    
    _divide_target_task_id : 0, 
    _divide_target_activity_id : 0,
    
    /**
     * show divide sub window.
     * 
     * @param {Number} task_id
     * @param {Stirng} task_title
     */
    _show_divide_sub_window : function(task_id, activity_id, task_title) {
      Tugboat.gtd_task.modal.open();

      var self = Tugboat.gtd_task.task_group;
      self._divide_target_task_id = task_id;
      self._divide_target_activity_id = activity_id;
      
      self._divide_task_inputs = [];
      self._create_divide_task_form();
      
      self._js_obj_task_ids = null;
      
      $('divide_task_title').value = task_title;
      
      self._divide_task_window = 
        new Window(
          'divideTaskWindow', 
          { className: 'mac_os_x', width:550, height:290, 
            zIndex: 100,
            minimizable: false,
            closable   : false,
            maximizable: false,
            resizable  : false,
            draggable  : true,
            title      : 'divide Task',
            showEffectOptions:{
              duration:0.3, 
              afterFinish:function(){
                $('divide_task_title').focus();

              }
            }
          }
        );
      self._divide_task_window.setContent('divide_task_window_container',false,false);
      self._divide_task_window.setDestroyOnClose();
      self._divide_task_window.showCenter();
      
      var new_task_group_window_observer = {
        onDestroy: function(eventName, win) {
          if (win == self._divide_task_window) {
            Element.hide('divide_task_window_container');
            $('divide_task_window_container').appendChild($('divide_task_form'));
            
            self._divide_task_window = null;
            self._is_processing = false;
            
            self._divide_target_task_id = 0;
            self._divide_target_activity_id = 0;
            
            self._divide_task_inputs = [];
            $('divide_tasks').innerHTML = '';
            
            Windows.removeObserver(this);
            Tugboat.gtd_task.modal.close();
            
            new Effect.Fade('small_balloon', {duration:4.0});
          }
        }
      };
      Windows.addObserver(new_task_group_window_observer);
    },
    
    /**
     * create divide task form.
     */
    _create_divide_task_form : function() {
      var self = Tugboat.gtd_task.task_group;
      var len = (self._divide_task_inputs ? self._divide_task_inputs.length : 0);
      var form_id       = 'divide_task_form_id-' + len;
      var input_text_id = 'divide_task_text_id-' + len;
      
      self._divide_task_inputs.push(
        {'form_id':form_id, 'input_text_id':input_text_id, 'del_flag':false}
      );
      $('divide_tasks').appendChild(
        FORM({
          'id': form_id,
          'onsubmit': function(){
            if (Tugboat.isEmpty($(input_text_id).value)) return false;
            self._create_divide_task_form();
            return false;
          }
        },
        [
          INPUT({'type':'text', 'id':input_text_id})
        ]
        )
      );
      if (len == 0) return false;
      var divide_task_input_value = self._divide_task_inputs[len-1];
      $(divide_task_input_value.form_id).appendChild(
        A({
          'href': 'javascript:void(0)',
          'onclick': function(){
            Element.remove(divide_task_input_value.form_id);
            self._divide_task_inputs[len-1].del_flag = true;
            this.blur();
          }
        },IMG({'src':'images/default/icon/trash2.gif'})
        )
      );
      $(input_text_id).focus();
    },
    
    /**
     * clear divide task form.
     */
    _post_divide_task : function() {
      Tugboat.gtd_task.modal.open();
      
      var self = Tugboat.gtd_task.task_group;
      self._is_processing = true;
      
      var posted_tasks = 0;
      
      var task_group_name = $('divide_task_title').value;
      var messages = [];
      if (Tugboat.isEmpty(task_group_name)) {
        messages.push('\'Task Group\' is required.');  
      }
      
      var has_input_values = true;
      if (self._divide_task_inputs.length == 1 
       && Tugboat.isEmpty($(self._divide_task_inputs[0].input_text_id).value)) {
         has_input_values = false;
         
      } else {
        var tasks = '';
        for (var i = 0; i < self._divide_task_inputs.length; i++) {
          var _divide_task = self._divide_task_inputs[i]; 
          if (! _divide_task.del_flag) {
            var task_title = $(_divide_task.input_text_id).value;
            if (Tugboat.isEmpty(task_title) && i < self._divide_task_inputs.length -1) {
              has_input_values = false;
              break;
            }
            if (! Tugboat.isEmpty(task_title)) {
              tasks += task_title.replace(/\x0D\x0A|\x0D|\x0A/g,'') + '\n';
              posted_tasks++;
            }
          }
        }
      }
      if (! has_input_values) {
        messages.push('\'Task(s)\' is required.');
      }
      if (messages.length > 0) {
        Tugboat.showAlertDialog( messages );
        
        self._is_processing = false;
        Tugboat.gtd_task.modal.close();
        return false;
      }
      
      // invoke.ajax-request.
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        { 
          method: Tugboat.constant.REQUEST_POST,
          parameters:
          {
            component     : 'taskGroupAjax',
            action        : 'divideTaskAndCreateTaskGroup',
            activityId    : self._divide_target_activity_id,
            taskId        : self._divide_target_task_id,
            title         : task_group_name,
            tasks         : tasks
          },
          onComplete: function(transport){
            self._js_obj_task_ids = eval(transport.responseText);
            
            var inbox_folder_resion = YAHOO.util.Dom.getRegion('folder_inbox');
            var small_balloon = $('small_balloon');
            var _messsage =
              'add ' + (posted_tasks == 1 ? 'a task.' : new String(posted_tasks) + ' tasks.');
            small_balloon.innerHTML = '';
            small_balloon.appendChild(P(null, _messsage));
            small_balloon.style.top = (inbox_folder_resion.top - 27)  + 'px';
            small_balloon.style.left = (inbox_folder_resion.right - 10) + 'px';
            small_balloon.style.display = 'block';

            Tugboat.gtd_task.folder.folder_onclick(
              Tugboat.constant.task.FOLDER_INBOX.id, true, null);

            self._select_list();

            Tugboat.gtd_task.modal.close();
            Windows.closeAll();
          }
        }
      );
    }
  }
};
